import React, { useEffect, useState } from 'react';
import TagCom from './IOTSwitch';
import { resolveRule } from '../../base/utils';

const Build: React.FC<any> = (props: any) => {
  const { attrData, uiStreams, ruleJson, buildHandler } = props;
  const [attr, setAttr] = useState<any>({});

  const handler = (item: any) => {
    const obj: any = {}
    obj[item['streamId']] = item['value'] ? '1' : '0';
    buildHandler(obj);
  }

  useEffect(() => {
    const streamId = attrData['streamId'];
    const curValue = uiStreams[streamId] === '1' ? true : false;
    const attr = resolveRule({ ...attrData, handler, curValue }, ruleJson, uiStreams);
    attr['originType'] && delete attr.originType;
    setAttr({ ...attr });
  }, [uiStreams,attrData]);

  return (<>
    {
      JSON.stringify(attr) === "{}" ?
        (<div></div>) :
        (<TagCom {...attr} />)
    }
  </>)
}

export default Build;
