import React from 'react';
import { ComponentsType, iBoolProps, iProperty, TagType } from '../../base/type';
import IOTEntry from './IOTEntry';
import { IOTEntryProps } from './interface';
import iConfig from 'iot-ui/esm/type';
import iGrapesJSConfig from '../../type';
import { mergeParameters } from '../../base/utils';

const grapesJSConfig: iGrapesJSConfig<IOTEntryProps, IOTEntryProps> = {
  type: [ComponentsType.Element],
  id: 'IOTEntry',
  tag: TagType.IOTEntry,
  access: 'rw',
  render: (jsonData, ...args) => {
    const props = mergeParameters(jsonData, ...args);
    return <IOTEntry {...props}></IOTEntry>;
  },
  buildData: (mock: boolean = false, property?: iProperty) => {
    //区分类
    const props: any = {
      title:'标题',
      subTitle: {
        show: true,
        value: '副标题',
      },
      icon: {
        value: 'insideicon-cu-1',
        show: true,
      },
    };
    return props;
  },
  traits: () => {
    return [
      {
        type: 'option-icon',
        name: 'icon',
        label: '显示图标',
      },
      {
        type: 'text',
        name: 'title',
        label: '',
      },
      {
        type: 'option-text',
        name: 'subTitle',
        label: '显示图标',
      },
      {
        type: 'bind-stream',
        name: 'list',
        label: '绑定功能',
      }
    ];
  },
};
export default grapesJSConfig;