import React from 'react';
import { ComponentsType, DataType, iProperty, TagType } from '../../base/type';
import IOTIconNavigation from './IOTIconNavigation';
import { IOTBottomSlideProps ,IOTBottomSlideJson} from './interface';
import iGrapesJSConfig from '../../type';
import { mergeParameters } from '../../base/utils';
import { getEnumItems } from '../../enum/IOTCordEntryEnum/grapesjsConfig';

 const grapesJSConfig: iGrapesJSConfig<IOTBottomSlideJson, IOTBottomSlideProps> = {
   type: [ComponentsType.Navigation],
   id: 'IOTIconNavigation',
   tag: TagType.IOTIconNavigation,
   access: 'rw',
   render: (jsonData, ...args) => {
     const props = mergeParameters(jsonData, ...args);
     if(props?.list?.length){
      props.list.forEach((item: { title: any; functionName: string; })=>{
        item.title = item.functionName || ''
      })
     }
     return <IOTIconNavigation {...props}></IOTIconNavigation>;
   },
   buildData: (mock: boolean = false, property?: iProperty) => {
     let configs = 4;
     const configItem = Array.from(new Array(configs),(item,index)=>({
      id: `navigation-${index}`,
      functionName: '导航功能',
      streamId: 'navigation',
      icon: 'insideicon-cu-1',
     }))
    //区分类
    const props: any = {
      title:'导航组件',
      streamId: 'navigation',
      type: 'Navigation',
      list: configItem,
    };
    return props;
   },
   traits: () => {
     return [
       {
        type: 'multiple-config',
        name: 'list',
        label: '添加配置',
        count: 24,
      },
     ];
   },
 };
export default grapesJSConfig;
