import React from 'react';
import { iIOTElementIconProps } from "./interface";
import './style/index.less';

const prefixCls = 'iot-element-icon';

const IOTIcon: React.FC<iIOTElementIconProps> = ({
  title,
  streamId,
  curValue,
  subTitle,
  icon,
  btnIcon,
  disabled,
  streamName,
  handler,
  ...rest
}) => {
  return (
    <div className={prefixCls} {...rest}>
      <div className={`power-icon ${disabled ? 'disabled' : ''} `} onClick={() => {
        const item: any = {
          value: !curValue,
          streamId,
        };
        handler?.(item);
      }}>
        <i className={`power-icon-img ${btnIcon ? btnIcon : 'insideicon-power'}  ${disabled ? 'disabled' : ''} `} />
      </div>

    </div>
  )
}

export default IOTIcon;
