import React from 'react';
import { ComponentsType, DataType, iProperty, TagType } from '../../base/type';
import IOTDirection from './IOTDirection';
import { iIOTDirectionProps } from './interface';
import iGrapesJSConfig from '../../type';
import { iIOTDirectionJSON } from '.';
import { mergeParameters } from '../../base/utils';


 const grapesJSConfig: iGrapesJSConfig<iIOTDirectionJSON, iIOTDirectionProps> = {
   type: [ComponentsType.EnumType],
   id: 'IOTDirection',
   tag: TagType.IOTDirection,
   access: 'rw',
   render: (jsonData, ...args) => {
     const props = mergeParameters(jsonData, ...args);
     return <IOTDirection {...props}></IOTDirection>;
   },
   buildData: (mock: boolean = false, property?: iProperty) => {
     if (property === undefined) return;
     //区分类
     const props: iIOTDirectionJSON = {
       title: property['display-name'],
       icon: { value: 'insideicon-cu-1', show: true },
       streamId: property.streamName,
       type: property?.valuedef?.type,
       disabled: false
     };
     return props;
   },
   traits: () => {
     return [
       {
         type: 'option-icon',
         name: 'icon',
         label: '显示图标',
       }
     ];
   },
 };
export default grapesJSConfig;
