import React, { useEffect, useState } from 'react';
import TagCom from './IOTIconGrid';
import { resolveRule } from '../../base/utils';

const Build: React.FC<any> = (props: any) => {
  const { attrData, uiStreams, ruleJson, buildHandler } = props;
  const [attr, setAttr] = useState<any>({});

  const handler = (item: any) => {
    const obj: any = {}
    obj[item['streamId']] = item['value'] + ''
    buildHandler(obj);
  }

  useEffect(() => {
    const streamId = attrData['streamId'];
    const curValue = uiStreams[streamId] === '' ? '-1' : uiStreams[streamId];
    const items = attrData['items'].map((item: any) => {
      return {
        ...item,
        checked: item['value'] === curValue,
        disabled: false,
      }
    })
    const attr = resolveRule({ ...attrData, handler, items }, ruleJson, uiStreams);
    attr['originType'] && delete attr.originType;
    setAttr({ ...attr });
  }, [uiStreams,attrData]);

  return (<>
    {
      JSON.stringify(attr) === "{}" ?
        (<div></div>) :
        (<TagCom {...attr} />)
    }
  </>)
}

export default Build;
