import { iNumberProps } from '../../base/type';
// 时 分 秒
export type DisplayTimeType = 'hh:mm:ss' | 'hh:mm' | 'mm:ss' | 'hh' | 'mm' | 'ss';
export type UnitType = 'h' | 'min' | 's'; // 传入时间组件的数据的单位 h:小时 min： 分钟 s：秒

export interface DisplayHelpInfos {
  minVal: number;
  maxVal: number;
  stepVal: number;
  displayTimeType: DisplayTimeType;
  initValue: number;
}
export interface TimeConver {
  hoursFlag: boolean; //时
  minutesFlag: boolean; //分
  secondsFlag: boolean; //秒
  descText: string; // 后缀文字
}
export interface IOTTimeSliderProps extends iNumberProps {
  curValue: string,
  startHandler?: (val: any) => void;
  endHandler?: (val: any) => void;
  leftIcon?: string;
  rightIcon?: string;
  timeConver: TimeConver;
  unit: UnitType;
}

export type iIOTTimeSliderJSON = IOTTimeSliderProps;