import { mergeParameters } from '../../base/utils';
import React from 'react';
// import { iIOTWeatherJSON } from '.';
import { ComponentsType, iProperty, TagType } from "../../base/type";
import iGrapesJSConfig from "../../type";
import { IOTAlertProps } from "./interface";
import IOTAlert from './IOTAlert';

const grapesJSConfig: iGrapesJSConfig<IOTAlertProps, IOTAlertProps> = {
  type: [ComponentsType.IOTAlert],
  id: TagType.IOTAlert,
  tag: TagType.IOTAlert,
  access: 'r',
  render: (jsonData, ...args) => {
    const props = mergeParameters(jsonData, ...args);

    return <IOTAlert {...props} />;
  },
  buildData: (mock: boolean = false, property?: iProperty) => {
    const props: IOTAlertProps = {
      message: "提示文案",
      type: "info",
      jugements: [],
      streams: {},
      isBuild:false,
    };
    return props;
  },
  traits: () => {
    return [
      {
        type: 'style-link',
        name: 'jugements',
        label: '添加配置',
      },
    ];
  },
};
export default grapesJSConfig;