import {iBaseProps} from '../../base/type';

export interface IOTConsumablesProps extends iBaseProps{
  handler: () => void;
  streamValue: number;
  thumbnailTheme1?: string;
  thumbnailTheme12?: string;
  consumablesList?: consumablesProps[];
  childrenIcon?: boolean
}

/**
 * @param id
 * @param parameter 绑定耗材余量参数
 * @param resetFirst 耗材重置第一个参数
 * @param resetLast 耗材重置最后一个参数
 * @param imgUrl 图片地址
 * @param explain 备注说明
 * @param recommendList 推荐列表
 * @param isDone 当前项表单是否完成填写
 * @param isRepeat 是否重复参数
 */
 interface consumablesProps {
  id: number;
  parameter?: any;
  resetFirst?: any;
  resetLast?: string;
  imgUrl?: string;
  explain?: string;
  recommendList?: any[];
  isDone?: boolean;
  isRepeat?: boolean
}

export enum currentValueType {
  normal = 'normal',
  error = 'error',
  warning = 'warning',
}


export type IOTConsumablesJSON = IOTConsumablesProps;