import { mergeParameters } from '../../base/utils';
import React from 'react';
// import { iIOTWeatherJSON } from '.';
import { ComponentsType, iProperty, TagType } from "../../base/type";
import iGrapesJSConfig from "../../type";
import { IIOTFaultAlarmProps } from "./type";
import IOTFaultAlarm from './IOTFaultAlarm';

const grapesJSConfig: iGrapesJSConfig<IIOTFaultAlarmProps, IIOTFaultAlarmProps> = {
  type: [ComponentsType.IOTFaultAlarm],
  id: TagType.IOTFaultAlarm,
  tag: TagType.IOTFaultAlarm,
  access: 'r',
  render: (jsonData, ...args) => {
    const props = mergeParameters(jsonData, ...args);

    return <IOTFaultAlarm {...props} />;
  },
  buildData: (mock: boolean = false, property?: iProperty) => {
    const props: IIOTFaultAlarmProps = {
      text: '进水阀故障，请检查设备是否有进水，水流是否减少。',
      type: 'middle',
      alarm: {
        title: 'asdfasdfa',
        errCode: '2736',
        solution: '这样解决掉它哦 ',
        contactTel: '999-999-999',
        code: '2'
      }
    };
    return props;
  },
  traits: () => {
    return [
      {
        type: 'image-card',
        name: 'faultAlarm',
        label: '故障告警',
        src: 'https://iotfestatic.s3.cn-north-1.jdcloud-oss.com/%E5%B0%8F%E4%BA%AC%E9%B1%BC%E5%B9%B3%E5%8F%B0/%E6%8B%96%E6%8B%BD%E5%B9%B3%E5%8F%B0%E9%9D%99%E6%80%81%E8%B5%84%E6%BA%90/errortips.png',
        style: { width: 228, height: 200 }
      },
    ];
  },
};
export default grapesJSConfig;