"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isIntType = exports.getMappingType = exports.getComponentsType = exports.TagType = exports.DataType = exports.ComponentsType = void 0;

/* eslint-disable @typescript-eslint/no-use-before-define */

/* eslint-disable @typescript-eslint/class-name-casing */

/**
 *组件样式
 *
 * @export
 * @interface ICompStyle
 */

/**
 *字体图标样式
 *
 * @export
 * @interface IIconStyle
 */

/**
 *icom 图标
 *
 * @export
 * @interface IIcon
 */
var isIntType = function isIntType(thingModelType) {
  switch (thingModelType) {
    case 'uint8':
    case 'uint16':
    case 'uint32':
    case 'int':
    case 'int8':
    case 'int16':
    case 'int32':
    case 'int64':
      return true;

    default:
      return false;
  }
};

exports.isIntType = isIntType;

var getMappingType = function getMappingType(thingModelType) {
  switch (thingModelType) {
    case 'uint8':
    case 'uint16':
    case 'uint32':
    case 'int':
    case 'int8':
    case 'int16':
    case 'int32':
    case 'int64':
      return DataType.IntType;

    case 'float':
    case 'double':
      return DataType.FloatType;

    default:
      break;
  }

  return thingModelType;
};

exports.getMappingType = getMappingType;
var DataType;
exports.DataType = DataType;

(function (DataType) {
  DataType["IntType"] = "int";
  DataType["FloatType"] = "float";
  DataType["BoolType"] = "bool";
  DataType["EnumType"] = "enum";
})(DataType || (exports.DataType = DataType = {}));

var getComponentsType = function getComponentsType(type) {
  switch (type) {
    case 'uint8':
    case 'uint16':
    case 'uint32':
    case 'int':
    case 'int8':
    case 'int16':
    case 'int32':
    case 'int64':
    case 'float':
    case 'double':
      return ComponentsType.NumberType;

    default:
      break;
  }

  return type;
};

exports.getComponentsType = getComponentsType;
var ComponentsType;
exports.ComponentsType = ComponentsType;

(function (ComponentsType) {
  ComponentsType["NumberType"] = "number";
  ComponentsType["BoolType"] = "bool";
  ComponentsType["EnumType"] = "enum";
  ComponentsType["WeatherType"] = "weather";
  ComponentsType["Layout"] = "Layout";
  ComponentsType["Element"] = "Element";
  ComponentsType["Custom"] = "Custom";
  ComponentsType["Consumables"] = "Consumables";
  ComponentsType["cloudTimer"] = "cloudTimer";
  ComponentsType["Navigation"] = "Navigation";
  ComponentsType["IOTDataLog"] = "IOTDataLog";
  ComponentsType["IOTAlert"] = "alert";
  ComponentsType["IOTFaultAlarm"] = "IOTFaultAlarm";
})(ComponentsType || (exports.ComponentsType = ComponentsType = {}));

var TagType;
exports.TagType = TagType;

(function (TagType) {
  TagType["IOTWeather"] = "IOTWeather";
  TagType["IOTPower"] = "IOTPower";
  TagType["IOTSwitch"] = "IOTSwitch";
  TagType["IOTCardMultiText"] = "IOTCardMultiText";
  TagType["IOTGrid"] = "IOTGrid";
  TagType["IOTCordEntryEnum"] = "IOTCordEntryEnum";
  TagType["IOTCordEntryNumber"] = "IOTCordEntryNumber";
  TagType["IOTIconSlider"] = "IOTIconSlider";
  TagType["IOTSlider"] = "IOTSlider";
  TagType["IOTTimeSlider"] = "IOTTimeSlider";
  TagType["IOTNavBar"] = "IOTNavBar";
  TagType["IOTMiniCardText"] = "IOTMiniCardText";
  TagType["IOTImg"] = "IOTImg";
  TagType["IOTEntry"] = "IOTEntry";
  TagType["IOTIcon"] = "IOTIcon";
  TagType["IOTDirection"] = "IOTDirection";
  TagType["IOTNumberSlider"] = "IOTNumberSlider";
  TagType["IOTDoubleButton"] = "IOTDoubleButton";
  TagType["IOTPoleSlider"] = "IOTPoleSlider";
  TagType["IOTIconGrid"] = "IOTIconGrid";
  TagType["IOTExecutePower"] = "IOTExecutePower";
  TagType["IOTCustom"] = "IOTCustom";
  TagType["IOTAlert"] = "IOTAlert";
  TagType["IOTNoPoleSlider"] = "IOTNoPoleSlider";
  TagType["IOTConsumables"] = "IOTConsumables";
  TagType["IOTTimeTask"] = "IOTTimeTask";
  TagType["IOTIconNavigation"] = "IOTIconNavigation";
  TagType["IOTFaultAlarm"] = "IOTFaultAlarm";
  TagType["IOTDataLog"] = "IOTDataLog";
})(TagType || (exports.TagType = TagType = {}));