"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

require("./style/index.less");

var _index2 = require("../../index");

var _utils = require("./utils");

var _excluded = ["list", "streamId", "specs"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-card-multi-text-out';

var getItem = function getItem(len) {
  var itemLen = len;
  var itemWidth = Math.floor(1 / itemLen * 100) + '%';
  var style = {
    gridTemplateColumns: "repeat(".concat(itemLen, ", ").concat(itemWidth, ")")
  }; // console.log(style);

  return style;
};

var IOTCardMultiText = function IOTCardMultiText(_ref) {
  var list = _ref.list,
      streamId = _ref.streamId,
      specs = _ref.specs,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      moreShow = _useState2[0],
      setMoreShow = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      allList = _useState4[0],
      setAllList = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      curList = _useState6[0],
      setCurList = _useState6[1];

  (0, _react.useEffect)(function () {
    var arr = [];

    if (list.length > 0 && list.length <= 3) {
      arr.push(list);
      setCurList(arr);
    } else {
      var len = Math.floor(list.length / 3);
      var sur = list.length % 3;

      if (sur > 0) {
        len = len + 1;
      } // console.log(len);


      for (var i = 0; i < len; i++) {
        arr.push(list.slice(i * 3, i * 3 + 3));
      }

      setAllList(arr); // setCurList(arr.slice(0, 2));

      if (moreShow) {
        setCurList(arr);
      } else {
        setCurList(arr.slice(0, 2));
      }
    }
  }, [list]);
  (0, _react.useEffect)(function () {
    if (allList.length < 2) return;

    if (moreShow) {
      setCurList(allList);
    } else {
      setCurList(allList.slice(0, 2));
    }
  }, [moreShow]);

  var timeConverHandler = function timeConverHandler(text, items) {
    var _items$label;

    if ((0, _index2.checkLabelContainTag)('7', (_items$label = items.label) !== null && _items$label !== void 0 ? _items$label : '')) {
      return (0, _utils.isSymbolFormatTime)(Number.parseInt(text), items.unit || 'min', items.unitConvertFlag);
    } else {
      return text;
    }
  };

  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "".concat(prefixCls + '-box', " ").concat(allList.length > 2 ? 'show-bord' : '')
  }, curList.map(function (lists, key) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "floor",
      style: getItem(lists.length),
      key: key
    }, lists.map(function (items, index) {
      return /*#__PURE__*/_react.default.createElement("div", {
        className: "card-items",
        key: index
      }, /*#__PURE__*/_react.default.createElement("div", {
        className: "card-title"
      }, items.title), /*#__PURE__*/_react.default.createElement("div", {
        className: "card-state-text"
      }, items.text ? timeConverHandler(items.text, items) : '- -'), /*#__PURE__*/_react.default.createElement("div", {
        className: "card-line"
      }));
    }));
  })), allList.length > 2 && /*#__PURE__*/_react.default.createElement("div", {
    className: "more-card",
    onClick: function onClick() {
      setMoreShow(!moreShow);
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "more-card-text "
  }, moreShow ? '收起信息' : '显示更多信息', " "), /*#__PURE__*/_react.default.createElement("div", {
    className: "more-card-icon insideicon-entry ".concat(moreShow ? 'show' : '')
  })));
};

var _default = IOTCardMultiText;
exports.default = _default;