"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../../base/utils");

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTCustom = _interopRequireDefault(require("./IOTCustom"));

var grapesJSConfig = {
  type: [_type.ComponentsType.Custom],
  id: 'IOTCustom',
  tag: _type.TagType.IOTCustom,
  access: 'r',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTCustom.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return; //区分类

    var props = {
      title: property['display-name'],
      streamId: property.streamName,
      type: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : _property$valuedef.type,
      disabled: false
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'text',
      name: 'title',
      label: '组件名',
      placeholder: '仅支持英文大小写及数字',
      getValidString: function getValidString(text) {
        var re = /[a-zA-Z0-9]+/;
        var result = re.exec(text);

        if (result) {
          return result[0];
        } else {
          return '';
        }
      }
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;