"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTEntry = _interopRequireDefault(require("./IOTEntry"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.Element],
  id: 'IOTEntry',
  tag: _type.TagType.IOTEntry,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTEntry.default, props);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    //区分类
    var props = {
      title: '标题',
      subTitle: {
        show: true,
        value: '副标题'
      },
      icon: {
        value: 'insideicon-cu-1',
        show: true
      }
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'option-text',
      name: 'subTitle',
      label: '显示图标'
    }, {
      type: 'bind-stream',
      name: 'list',
      label: '绑定功能'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;