"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _IOTAllGrid = _interopRequireDefault(require("../../enum/IOTAllGrid"));

var _IOTNumberSlider = _interopRequireDefault(require("../../number/IOTCordEntryNumber/IOTNumberSlider"));

var _sliderConfig = require("../../number/sliderConfig");

var _react = _interopRequireWildcard(require("react"));

var _IOTBottomSlide = _interopRequireDefault(require("../IOTBottomSlide"));

require("./style/index.less");

var _this = void 0;

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var IOTIconNavigation = function IOTIconNavigation(props) {
  var _list$length;

  var list = props.list,
      source = props.source,
      disabled = props.disabled;

  var _useState = (0, _react.useState)(-1),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      select = _useState2[0],
      setSelect = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      btm = _useState4[0],
      setBtm = _useState4[1];

  var _useState5 = (0, _react.useState)(''),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      title = _useState6[0],
      setTitle = _useState6[1];

  var boolRef = (0, _react.useRef)(false); // 枚举

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      middleList = _useState8[0],
      setMiddleList = _useState8[1];

  var _useState9 = (0, _react.useState)([]),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      modelTopList = _useState10[0],
      setModelTopList = _useState10[1];

  var _useState11 = (0, _react.useState)([]),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      modelFootList = _useState12[0],
      setModelFootList = _useState12[1]; // number


  var _useState13 = (0, _react.useState)({
    streamId: 'string',
    max: "255.0",
    min: "0.0",
    step: "1",
    unit: '℃',
    unitdesc: '摄氏度',
    curValue: '',
    intType: ''
  }),
      _useState14 = (0, _slicedToArray2.default)(_useState13, 2),
      numberSlider = _useState14[0],
      setNumberSlider = _useState14[1];

  var sliderVal = (0, _react.useRef)(0);

  var _useState15 = (0, _react.useState)('enum'),
      _useState16 = (0, _slicedToArray2.default)(_useState15, 2),
      type = _useState16[0],
      setType = _useState16[1];

  var handlerRef = (0, _react.useRef)(function (e) {});

  var click = function click(item, index) {
    // 置灰点击不可用
    if (item.disabled) return;

    if (item !== null && item !== void 0 && item.handler) {
      handlerRef.current = item === null || item === void 0 ? void 0 : item.handler;
    } else {
      handlerRef.current = function () {};
    }

    setType(item.type || 'enum');

    switch (item.type) {
      case 'bool':
        var obj = {
          streamId: item.streamId,
          value: !item.curValue
        };
        item.handler && item.handler(obj);
        break;

      case 'number':
        var sliderItem = {
          streamId: item.streamId,
          max: item.max,
          min: item.min,
          step: item.step,
          unit: item.unit,
          unitdesc: item.unitdesc,
          curValue: item.curValue || item.min,
          intType: item.intType
        };
        setNumberSlider(sliderItem);
        setTitle(item.title || '');
        setBtm(true);
        break;

      case 'enum':
        var items = item.items,
            curValue = item.curValue;

        if (items.length > 0) {
          items.map(function (currentItem) {
            if (currentItem.value === curValue) {
              currentItem.checked = true;
            }
          }); // if( items[curValue] &&'checked' in items[curValue]){
          //   items[curValue].checked = true;
          // }

          (modelTopList === null || modelTopList === void 0 ? void 0 : modelTopList.length) && setModelTopList([]);
          (middleList === null || middleList === void 0 ? void 0 : middleList.length) && setMiddleList([]);
          (modelFootList === null || modelFootList === void 0 ? void 0 : modelFootList.length) && setModelFootList([]);

          if (items.length > 0 && items.length <= 4) {
            setModelTopList((0, _toConsumableArray2.default)(items));
          } else if (items.length > 4 && items.length <= 8) {
            var topArr;
            var footArr;

            if (items.length === 5) {
              topArr = items.slice(0, 3);
              footArr = items.slice(3);
            } else if (items.length === 6) {
              topArr = items.slice(0, 3);
              footArr = items.slice(3);
            } else {
              topArr = items.slice(0, 4);
              footArr = items.slice(4);
            }

            setModelTopList((0, _toConsumableArray2.default)(topArr));
            setModelFootList((0, _toConsumableArray2.default)(footArr));
          } else if (items.length > 8) {
            var l = items.length;
            var n = Math.floor(l / 4);
            var m = l % 4;

            if (m > 0) {
              n = n + 1 - 2;
            } else {
              n = n - 2;
            }

            var arr = items.slice(4, l - m);
            var middle = [];

            for (var i = 0; i < n; i++) {
              var _item = arr.slice(i * 4, i * 4 + 4);

              middle.push(_item);
            }

            var _topArr = items.slice(0, 4);

            var footArrMode = m === 0 ? items.slice(l - 4) : items.slice(l - m);
            setMiddleList(middle);
            setModelTopList((0, _toConsumableArray2.default)(_topArr));
            var mentalist = [];

            if (m > 0) {
              for (var _i = 0; _i < 4 - m; _i++) {
                var _item2 = {
                  value: null,
                  text: '',
                  icon: '',
                  checked: false
                };
                mentalist.push(_item2);
              }
            }

            setModelFootList([].concat((0, _toConsumableArray2.default)(footArrMode), mentalist));
          }
        }

        setTitle(item.title || '');
        setBtm(true);
        break;

      default:
        item.handler && item.handler();
        setSelect(index);
        boolRef.current = false;
        break;
    }
  };

  var bottomSliderProps = {
    leftText: title,
    rightText: '取消',
    type: 'show',
    title: title,
    confirmHandler: function confirmHandler(val) {
      setTimeout(function () {
        var bodyDom = document.querySelectorAll('body');
        bodyDom[0].style.overflow = 'auto';
        setBtm(false);
      }, 500);
    }
  };

  if (type === 'number') {
    bottomSliderProps = {
      leftText: '取消',
      rightText: '确定',
      type: 'com',
      title: title,
      confirmHandler: function confirmHandler(val) {
        if (val) {
          var item = {
            streamId: numberSlider.streamId,
            value: sliderVal.current
          };
          console.log(item);
          handlerRef.current && handlerRef.current(item);
        }

        setBtm(false);
      }
    };
  }

  var len = (_list$length = list === null || list === void 0 ? void 0 : list.length) !== null && _list$length !== void 0 ? _list$length : 0;
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-navigation-out"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-navigation ".concat(source),
    style: len > 4 ? {
      justifyContent: 'flex-start'
    } : {}
  }, list === null || list === void 0 ? void 0 : list.map(function (item, index) {
    var _item$icon;

    if (!item) return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null);
    var light = select === index;

    if (item.type === 'bool') {
      light = item.curValue;
    }

    return /*#__PURE__*/_react.default.createElement("div", {
      className: "iot-navigation-content",
      style: len > 4 ? {
        marginBottom: '0.1rem'
      } : {},
      key: "".concat(item.title, "-").concat(index)
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "navigation-entry-enum-icon ".concat(light ? 'active' : 'default'),
      onClick: click.bind(_this, item, index)
    }, /*#__PURE__*/_react.default.createElement("span", {
      className: ['navigation-entry-enum-icon-image', (_item$icon = item === null || item === void 0 ? void 0 : item.icon) !== null && _item$icon !== void 0 ? _item$icon : 'insideicon-cu-1'].join(' ')
    })), /*#__PURE__*/_react.default.createElement("p", null, item.title), item.disabled ? /*#__PURE__*/_react.default.createElement("div", {
      className: "disabled"
    }) : null);
  }))), /*#__PURE__*/_react.default.createElement(_IOTBottomSlide.default, (0, _extends2.default)({
    isShow: btm
  }, bottomSliderProps), type === 'enum' ? /*#__PURE__*/_react.default.createElement(_IOTAllGrid.default, {
    modelTopList: modelTopList,
    middleList: middleList,
    modelFootList: modelFootList,
    styleType: "1",
    control: function control(val) {
      handlerRef.current && handlerRef.current(val);
      setTimeout(function () {
        var bodyDom = document.querySelectorAll('body');
        bodyDom[0].style.overflow = 'auto';
        setBtm(false);
      }, 500);
    }
  }) : /*#__PURE__*/_react.default.createElement(_IOTNumberSlider.default, {
    min: Number.parseFloat(numberSlider.min),
    max: Number.parseFloat(numberSlider.max),
    step: Number.parseFloat(numberSlider.step),
    intType: numberSlider.intType,
    unit: numberSlider.unit,
    isStep: numberSlider.step === '1' && Math.round((Number.parseFloat(numberSlider.max) - Number.parseFloat(numberSlider.min)) / Number.parseFloat(numberSlider.step)) > 50,
    showHandleBtn: false,
    curValue: numberSlider.curValue + '',
    dotsData: (0, _sliderConfig.dataSource)(numberSlider.min, numberSlider.max, numberSlider.step),
    disabled: false,
    onchange: function onchange(val) {
      sliderVal.current = val;
    },
    move: function move(val) {},
    start: function start() {}
  })));
};

var _default = IOTIconNavigation;
exports.default = _default;