"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTIconNavigation = _interopRequireDefault(require("./IOTIconNavigation"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.Navigation],
  id: 'IOTIconNavigation',
  tag: _type.TagType.IOTIconNavigation,
  access: 'rw',
  render: function render(jsonData) {
    var _props$list;

    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    if (props !== null && props !== void 0 && (_props$list = props.list) !== null && _props$list !== void 0 && _props$list.length) {
      props.list.forEach(function (item) {
        item.title = item.functionName || '';
      });
    }

    return /*#__PURE__*/_react.default.createElement(_IOTIconNavigation.default, props);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    var configs = 4;
    var configItem = Array.from(new Array(configs), function (item, index) {
      return {
        id: "navigation-".concat(index),
        functionName: '导航功能',
        streamId: 'navigation',
        icon: 'insideicon-cu-1'
      };
    }); //区分类

    var props = {
      title: '导航组件',
      streamId: 'navigation',
      type: 'Navigation',
      list: configItem
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'multiple-config',
      name: 'list',
      label: '添加配置',
      count: 24
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;