"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _IOTMiniCardText = _interopRequireDefault(require("./IOTMiniCardText"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Build = function Build(props) {
  var attrData = props.attrData,
      uiStreams = props.uiStreams;

  var _useState = (0, _react.useState)({}),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      attr = _useState2[0],
      setAttr = _useState2[1];

  (0, _react.useEffect)(function () {
    var list = [];
    var listObj = attrData['list'].map(function (item) {
      if (JSON.stringify(item) === '{}') return {};
      var streamId = item['streamId'];
      var text = '';
      var curValue = uiStreams[streamId];
      var cardType = item['valueDef']['type'];

      if (cardType === 'bool') {
        var specs = item['valueDef']['specs'];
        text = specs[curValue];
      } else if (cardType === 'enum') {
        var _specs = item['valueDef']['specs']['values'];
        text = _specs[curValue];
      } else {
        text = curValue;
      }

      var unit = '';

      try {
        unit = item['valueDef']['specs']['unit'];
        unit = unit ? unit : '';
      } catch (e) {
        console.error('IOTCardMultiText 解析异常');
      }

      var obj = {
        title: item['functionName'],
        unit: item['unit'] ? item['unit'] : 'min',
        text: text ? text + (item['label'] === '7' ? '' : unit) : '',
        label: item['label'],
        unitConvertFlag: item['unitConvertFlag']
      };
      ;
      return obj;
    });
    listObj.map(function (items) {
      if (JSON.stringify(items) !== '{}') {
        list.push(items);
      }
    });
    setAttr({
      list: list
    });
  }, [uiStreams, attrData]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, JSON.stringify(attr) === "{}" ? /*#__PURE__*/_react.default.createElement("div", null) : /*#__PURE__*/_react.default.createElement(_IOTMiniCardText.default, attr));
};

var _default = Build;
exports.default = _default;