"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _utils = require("../../base/utils");

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTMiniCardText = _interopRequireDefault(require("./IOTMiniCardText"));

var _index = require("../../index");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var grapesJSConfig = {
  type: [_type.ComponentsType.BoolType, _type.ComponentsType.EnumType, _type.ComponentsType.NumberType],
  id: 'IOTMiniCardText',
  tag: _type.TagType.IOTMiniCardText,
  access: 'r',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    var list = props.list;
    var renderList = Array();
    list.forEach(function (item) {
      var _item$functionName;

      var valueDef = item.valueDef;

      if (!valueDef) {
        valueDef = {};
      }

      renderList.push({
        title: getShowTitle(valueDef.type, valueDef.specs, (_item$functionName = item === null || item === void 0 ? void 0 : item.functionName) !== null && _item$functionName !== void 0 ? _item$functionName : '', false),
        text: getShowText(valueDef.type, valueDef.specs, item.label),
        label: item.label,
        unit: item.unit,
        unitConvertFlag: item.unitConvertFlag
      });
    });
    props.list = renderList;
    return /*#__PURE__*/_react.default.createElement(_IOTMiniCardText.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return;
    var configItem = {
      id: property.id,
      streamName: property['display-name'],
      functionName: property['display-name'],
      streamId: property.streamName,
      valueDef: property.valuedef,
      label: property.label,
      unit: property === null || property === void 0 ? void 0 : property.valuedef.specs.unit,
      unitConvertFlag: {
        hour: (property === null || property === void 0 ? void 0 : property.valuedef.specs.unit) === 'h',
        minute: (property === null || property === void 0 ? void 0 : property.valuedef.specs.unit) === 'min',
        second: (property === null || property === void 0 ? void 0 : property.valuedef.specs.unit) === 's'
      }
    }; //区分类

    var props = {
      title: property['display-name'],
      streamId: property.streamName,
      type: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : _property$valuedef.type,
      disabled: false,
      list: [_objectSpread({}, configItem)]
    };

    if (mock) {
      props.list = [configItem];
    }

    return props;
  },
  traits: function traits() {
    return [{
      type: 'function-config',
      name: 'list',
      label: '添加配置',
      count: 2
    }];
  }
};
var _default = grapesJSConfig; // const getValuesFromEnumProperty = (property: iConfigItem) => {
//   const enumValues = [];
//   for (const key in property.valueDef.specs.values) {
//     enumValues.push({
//       value: key,
//       text: property.valueDef.specs.values[key],
//     });
//   }
//   return enumValues;
// };
// const getDesc  = (config:iConfigItem) =>  {
//   const streamType = getMappingType(config?.valueDef?.type);
//   if (streamType === DataType.EnumType) {
//     const items = getValuesFromEnumProperty(config);
//     const desc = items.reduce((accumulator: any, item: any) => {
//       return {
//         value: '0',
//         text: accumulator['text'] + ',' + item['text'],
//       };
//     });
//     return desc.text as string;
//   } else if (streamType === DataType.FloatType || streamType === DataType.IntType) {
//     return '';
//   } else if (streamType === DataType.BoolType) {
//     const desc: Array<string> = [];
//     Object.keys(config.valueDef.specs).forEach((key: string) => {
//       desc.push(config.valueDef.specs[key]);
//     });
//     return desc.join(',');
//   }
//   return '';
// }

exports.default = _default;

var getShowText = function getShowText(type, specs, label) {
  var mappingType = (0, _type.getMappingType)(type);
  var returnStr = '- -';

  if (specs) {
    if (mappingType === _type.DataType.EnumType) {
      var key = Object.keys(specs.values)[0];

      if (key) {
        returnStr = specs.values[key];
      }
    } else if (mappingType === _type.DataType.FloatType || mappingType === _type.DataType.IntType) {
      var min = specs['min'];
      var unit = specs['unit'];
      returnStr = "".concat(min);

      if (!(0, _index.checkLabelContainTag)('7', label !== null && label !== void 0 ? label : '')) {
        returnStr = "".concat(min).concat(unit !== null && unit !== void 0 ? unit : '');
      }
    } else if (mappingType === _type.DataType.BoolType) {
      var _key2 = Object.keys(specs)[0];

      if (_key2) {
        returnStr = specs[_key2];
      }
    }
  }

  return returnStr;
};

var getShowTitle = function getShowTitle(type, specs, streamName, addUnit) {
  var mappingType = (0, _type.getMappingType)(type);
  var unit = '';

  if (specs) {
    if (mappingType === _type.DataType.FloatType || mappingType === _type.DataType.IntType) {
      unit = specs['unit'];
    }
  } else {
    if (!streamName || streamName.length == 0) {
      return '功能名称';
    }
  }

  if (addUnit) {
    var _unit;

    return "".concat(streamName).concat((_unit = unit) !== null && _unit !== void 0 ? _unit : '');
  } else {
    return "".concat(streamName);
  }
};