"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTIcon = _interopRequireDefault(require("./IOTIcon"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.Element],
  id: 'IOTIcon',
  tag: _type.TagType.IOTIcon,
  access: 'r',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTIcon.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return;
    var props = {
      title: property['display-name'],
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      streamId: property.streamName,
      type: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : _property$valuedef.type,
      disabled: false,
      btnIcon: '',
      //按钮图标
      curValue: true
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'upload',
      name: 'imgSrc',
      label: '图片设置'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;