"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getEnumItems = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTCordEntryEnum = _interopRequireDefault(require("./IOTCordEntryEnum"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.EnumType],
  id: 'IOTCordEntryEnum',
  tag: _type.TagType.IOTCordEntryEnum,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTCordEntryEnum.default, jsonData);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return; //区分类

    var props = {
      title: property['display-name'],
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      subTitle: {
        show: true,
        value: '副标题'
      },
      streamId: property.streamName,
      type: _type.DataType.EnumType,
      disabled: false,
      handler: function handler(val) {
        throw new Error('Function not implemented.');
      },
      items: getEnumItems(property)
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'option-text',
      name: 'subTitle',
      label: '副标题'
    }, {
      type: 'solt-text',
      name: 'items',
      label: '枚举列表'
    }];
  }
};

var getEnumItems = function getEnumItems(propery) {
  var _propery$valuedef, _propery$valuedef$spe;

  var items = Array();
  var values = propery === null || propery === void 0 ? void 0 : (_propery$valuedef = propery.valuedef) === null || _propery$valuedef === void 0 ? void 0 : (_propery$valuedef$spe = _propery$valuedef.specs) === null || _propery$valuedef$spe === void 0 ? void 0 : _propery$valuedef$spe.values;

  for (var key in values) {
    // 对此对象属性中的每个键执行的代码
    items.push({
      text: values["".concat(key)],
      value: key,
      icon: 'insideicon-cu-1'
    });
  }

  return items;
};

exports.getEnumItems = getEnumItems;
var _default = grapesJSConfig;
exports.default = _default;