"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _down = _interopRequireDefault(require("./static/down.png"));

require("./style/index.less");

var _excluded = ["subTitle", "type", "streamId", "handler", "clickHandler"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-direction';

var SliderControl = function SliderControl(_ref) {
  var subTitle = _ref.subTitle,
      type = _ref.type,
      streamId = _ref.streamId,
      _ref$handler = _ref.handler,
      handler = _ref$handler === void 0 ? function (val) {} : _ref$handler,
      _ref$clickHandler = _ref.clickHandler,
      clickHandler = _ref$clickHandler === void 0 ? function (val) {} : _ref$clickHandler,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);
  var controlRef = (0, _react.useRef)();

  var _useState = (0, _react.useState)('up'),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      direction = _useState2[0],
      setDirection = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      active = _useState4[0],
      setActive = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      showArrow = _useState6[0],
      setShowArrow = _useState6[1];

  var _useState7 = (0, _react.useState)(0),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      startX = _useState8[0],
      setStartX = _useState8[1];

  var _useState9 = (0, _react.useState)(0),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      startY = _useState10[0],
      setStartY = _useState10[1];

  var _useState11 = (0, _react.useState)(false),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      isTouched = _useState12[0],
      setTouched = _useState12[1];

  var hideArrowTimer = null;

  var startHandle = function startHandle(e) {
    var touches = e.changedTouches[0];
    setStartX(touches.clientX);
    setStartY(touches.clientY);
    setShowArrow(false);
  };

  var moveHandle = function moveHandle() {
    document.documentElement.style.overflow = 'hidden';
    setTouched(true);
    setActive(true);

    if (showArrow) {
      setShowArrow(false);
    }

    if (hideArrowTimer) {
      clearTimeout(hideArrowTimer);
    }
  };

  var endHandle = function endHandle(e) {
    document.documentElement.style.overflow = 'auto';
    var direction = 'up';
    var touches = e.changedTouches[0];
    var currentX = touches.clientX;
    var currentY = touches.clientY;
    var diffX = currentX - startX;
    var diffY = currentY - startY;
    var absDiffX = Math.abs(diffX);
    var absDiffY = Math.abs(diffY);

    if (isTouched) {
      if (absDiffX * 0.8 > absDiffY) {
        direction = diffX > 0 ? 'right' : 'left'; // setDirection(diffX > 0 ? 'right' : 'left')
      } else {
        direction = diffY > 0 ? 'down' : 'up'; // setDirection(diffX < 0 ? 'down' : 'up');
      }

      setShowArrow(true);
      setTouched(false);
      controlDevice(direction);
    } // 在滑动结束后隐藏滑动箭头;


    hideArrowTimer = setTimeout(function () {
      setShowArrow(false);
      setActive(false);
    }, 200);
  };

  var clickHandle = function clickHandle() {
    setActive(true);
    var item = {
      streamId: streamId
    };
    clickHandler === null || clickHandler === void 0 ? void 0 : clickHandler(item);
    setTimeout(function () {
      setActive(false);
    }, 600);
  };

  var controlDevice = function controlDevice(direction) {
    var item = {
      streamId: streamId,
      value: direction
    };
    handler === null || handler === void 0 ? void 0 : handler(item);
  };

  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    ref: controlRef // className={`slider-control ${active ? 'active' : ''}`}
    ,
    className: prefixCls,
    onTouchStart: startHandle,
    onTouchMove: moveHandle,
    onTouchEnd: endHandle,
    onTouchCancel: endHandle,
    onClick: clickHandle
  }, rest), /*#__PURE__*/_react.default.createElement("span", null, "\u671D\u7BAD\u5934\u65B9\u5411\u6ED1\u52A8\u53EF\u8C03\u8282\u65B9\u5411"), /*#__PURE__*/_react.default.createElement("span", {
    style: {
      marginTop: '.08rem'
    }
  }, "\u70B9\u51FB\u4E2D\u95F4\u533A\u57DF\u53EF\u786E\u5B9A/\u64AD\u653E/\u6682\u505C"), [1, 2, 3, 4].map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement("img", {
      src: _down.default,
      key: 'img' + index,
      className: "control-img control-img-".concat(index + 1),
      alt: ""
    });
  }));
};

var _default = SliderControl;
exports.default = _default;