"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

require("./style/index.less");

var _excluded = ["title", "streamId", "curValue", "subTitle", "icon", "btnIcon", "disabled", "streamName", "executeValue", "isBuild", "handler"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-execute-power-out';

var IOTExecutePower = function IOTExecutePower(_ref) {
  var title = _ref.title,
      streamId = _ref.streamId,
      curValue = _ref.curValue,
      subTitle = _ref.subTitle,
      icon = _ref.icon,
      btnIcon = _ref.btnIcon,
      disabled = _ref.disabled,
      streamName = _ref.streamName,
      executeValue = _ref.executeValue,
      _ref$isBuild = _ref.isBuild,
      isBuild = _ref$isBuild === void 0 ? false : _ref$isBuild,
      handler = _ref.handler,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      clickActive = _useState2[0],
      setClickActive = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      textActive = _useState4[0],
      setTextActive = _useState4[1];

  var timer1 = null;
  var timer2 = null;
  (0, _react.useEffect)(function () {
    if (clickActive) {
      timer1 = setTimeout(function () {
        setClickActive(false);
      }, 1500);
    }
  }, [clickActive]);
  (0, _react.useEffect)(function () {
    if (textActive) {
      timer2 = setTimeout(function () {
        setTextActive(false);
      }, 1000);
    }
  }, [textActive]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-power"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "power-left"
  }, (icon === null || icon === void 0 ? void 0 : icon.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "power-icon"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: ['power-icon-image', icon !== null && icon !== void 0 && icon.value ? icon.value : 'insideicon-cu-1'].join(' ')
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "power-title",
    style: {
      marginLeft: icon !== null && icon !== void 0 && icon.show ? '0' : '.2rem'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "power-main"
  }, title), (subTitle === null || subTitle === void 0 ? void 0 : subTitle.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "power-sub"
  }, subTitle['value']))), /*#__PURE__*/_react.default.createElement("div", {
    className: "power-right ".concat(clickActive ? 'active' : ''),
    onClick: function onClick() {
      if (!executeValue || clickActive) return;
      var item = {
        value: executeValue,
        streamId: streamId
      };
      handler === null || handler === void 0 ? void 0 : handler(item);
      clearTimeout(timer1);
      clearTimeout(timer2);
      setClickActive(true);
      timer2 = setTimeout(function () {
        setTextActive(true);
      }, 500);
    }
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: "power-btn"
  }, "\u6267\u884C", clickActive && /*#__PURE__*/_react.default.createElement("span", {
    className: "power-btn-span ".concat(textActive ? 'animation' : 'stop', " ")
  }, "\u6267\u884C"))), disabled && /*#__PURE__*/_react.default.createElement("div", {
    className: "power-disable"
  }))));
};

var _default = IOTExecutePower;
exports.default = _default;