"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTExecutePower = _interopRequireDefault(require("./IOTExecutePower"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.NumberType, _type.ComponentsType.BoolType, _type.ComponentsType.EnumType],
  id: 'IOTExecutePower',
  tag: _type.TagType.IOTExecutePower,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTExecutePower.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return; // 区分类

    var props = {
      title: property['display-name'],
      subTitle: {
        value: '副标题',
        show: true
      },
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      streamId: property.streamName,
      type: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : _property$valuedef.type,
      disabled: false
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'option-text',
      name: 'subTitle',
      label: '可选副标题'
    }, {
      type: 'select',
      name: 'executeValue',
      placeholder: '点击选择要执行的功能',
      label: '执行指令',
      options: 'streamId'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;