"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTGrid = _interopRequireDefault(require("./IOTGrid"));

var _utils = require("../../base/utils");

var _grapesjsConfig = require("../IOTCordEntryEnum/grapesjsConfig");

var grapesJSConfig = {
  type: [_type.ComponentsType.EnumType],
  id: 'IOTGrid',
  tag: _type.TagType.IOTGrid,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTGrid.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return; //区分类

    var props = {
      title: property['display-name'],
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      streamId: property.streamName,
      type: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : _property$valuedef.type,
      disabled: false,
      //  handler: function (val: any): void {
      //    throw new Error('Function not implemented.');
      //  },
      items: (0, _grapesjsConfig.getEnumItems)(property),
      styleType: '1'
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'select',
      name: 'styleType',
      label: '选择样式',
      options: [{
        value: '1',
        text: '矩形文本样式'
      }, {
        value: '2',
        text: '椭圆文本样式'
      }]
    }, {
      type: 'solt-text',
      name: 'items',
      label: '枚举列表'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;