"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _ModelItem = _interopRequireDefault(require("./ModelItem/ModelItem"));

require("./style/index.less");

var _excluded = ["streamId", "icon", "title", "subTitle", "disabled", "items", "handler", "childrenIcon"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-icon-grid-out';

var getItem = function getItem(len) {
  var itemLen = len;
  var itemWidth = Math.floor(1 / itemLen * 100) + '%';
  var style = {
    gridTemplateColumns: "repeat(".concat(itemLen, ", ").concat(itemWidth, ")")
  }; // console.log(style);

  return style;
};

var IOTIconGrid = function IOTIconGrid(_ref) {
  var streamId = _ref.streamId,
      icon = _ref.icon,
      title = _ref.title,
      subTitle = _ref.subTitle,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      items = _ref.items,
      _ref$handler = _ref.handler,
      handler = _ref$handler === void 0 ? function (val) {} : _ref$handler,
      _ref$childrenIcon = _ref.childrenIcon,
      childrenIcon = _ref$childrenIcon === void 0 ? false : _ref$childrenIcon,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      moreChoose = _useState2[0],
      setMoreChoose = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      moreChooseText = _useState4[0],
      setMoreChooseText = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      top1List = _useState6[0],
      setTop1List = _useState6[1];

  var _useState7 = (0, _react.useState)([]),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      topList = _useState8[0],
      setTopList = _useState8[1];

  var _useState9 = (0, _react.useState)([]),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      middleList = _useState10[0],
      setMiddleList = _useState10[1];

  var _useState11 = (0, _react.useState)([]),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      footList = _useState12[0],
      setFootList = _useState12[1];

  var _useState13 = (0, _react.useState)([]),
      _useState14 = (0, _slicedToArray2.default)(_useState13, 2),
      modelTopList = _useState14[0],
      setModelTopList = _useState14[1];

  var _useState15 = (0, _react.useState)([]),
      _useState16 = (0, _slicedToArray2.default)(_useState15, 2),
      modelFootList = _useState16[0],
      setModelFootList = _useState16[1];

  (0, _react.useEffect)(function () {
    if (items.length > 0) {
      if (items.length > 0 && items.length <= 4) {
        setTopList((0, _toConsumableArray2.default)(items));
        setFootList([]);
        setMoreChoose(false);
      }

      if (items.length > 4 && items.length <= 8) {
        var topArr;
        var footArr;

        if (items.length === 5) {
          topArr = items.slice(0, 3);
          footArr = items.slice(3);
        } else if (items.length === 6) {
          topArr = items.slice(0, 3);
          footArr = items.slice(3);
        } else {
          topArr = items.slice(0, 4);
          footArr = items.slice(4);
        }

        setTopList((0, _toConsumableArray2.default)(topArr));
        setFootList((0, _toConsumableArray2.default)(footArr));
        setMoreChoose(false);
      }

      if (items.length > 8) {
        var l = items.length;
        var n = Math.floor(l / 4);
        var m = l % 4; // console.log(l, 'llll');
        // console.log(m, 'mmmmm');

        if (m > 0) {
          n = n + 1 - 2;
        } else {
          n = n - 2;
        } // console.log(n, 'nnnnnn');


        var arr = items.slice(4, l - m); // console.log(arr, 'arr');

        var middle = [];

        for (var i = 0; i < n; i++) {
          var item = arr.slice(i * 4, i * 4 + 4); // console.log(item, 'arr');

          middle.push(item);
        } // console.log(middle, 'middle~~~~');


        var _topArr = items.slice(0, 4);

        var footArrMode = m === 0 ? items.slice(l - 4) : items.slice(l - m);

        var _footArr = items.slice(4, 8);

        setMiddleList(middle);
        setModelTopList((0, _toConsumableArray2.default)(_topArr));
        setTopList((0, _toConsumableArray2.default)(_topArr));
        var mentalist = []; // console.log(m, 'm========');

        if (m > 0) {
          for (var _i = 0; _i < 4 - m; _i++) {
            var _item = {
              value: null,
              text: '',
              icon: '',
              checked: false
            };
            mentalist.push(_item);
          }
        }

        setModelFootList([].concat((0, _toConsumableArray2.default)(footArrMode), mentalist));
        setFootList((0, _toConsumableArray2.default)(_footArr));
        var list = items.slice(0, 8);
        var flag = false;
        var text = '';
        items.map(function (item) {
          if (item.checked) {
            text = item.text;
          }
        });

        if (text !== '') {
          list.map(function (item) {
            if (item.checked) {
              flag = true;
            }
          });
          setMoreChoose(!flag);
        } else {
          setMoreChoose(false);
        }

        setMoreChooseText(text);
      }
    }
  }, [items]);
  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-icon-grid"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-icon-grid-top"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-icon-grid-left"
  }, (icon === null || icon === void 0 ? void 0 : icon.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-grid-icon"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: ['iot-grid-icon-image', icon !== null && icon !== void 0 && icon.value ? icon.value : 'insideicon-cu-1'].join(' ')
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-grid-title",
    style: {
      marginLeft: icon !== null && icon !== void 0 && icon.show ? '0' : '.2rem'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-grid-main",
    style: {
      marginRight: moreChoose ? '0' : 'var(--operation-margin-LR)'
    }
  }, title))), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-icon-grid-right",
    style: {
      display: "".concat(moreChoose ? 'inline-block' : 'none')
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-grid-more-title"
  }, "\u5DF2\u9009\u62E9: ", moreChooseText))), /*#__PURE__*/_react.default.createElement("div", {
    className: "item-list"
  }, /*#__PURE__*/_react.default.createElement(_ModelItem.default, {
    title: title // top1List={top1List}
    ,
    topList: topList,
    modelTopList: modelTopList,
    footList: footList,
    middleList: middleList,
    showMore: items.length > 8,
    modelFootList: modelFootList,
    control: function control(val) {
      val['streamId'] = streamId;
      handler === null || handler === void 0 ? void 0 : handler(val);
    }
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "disabled-pangle",
    style: {
      display: "".concat(disabled ? 'block' : 'none')
    }
  })));
};

var _default = IOTIconGrid;
exports.default = _default;