"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _poleSlider = _interopRequireDefault(require("./poleSlider"));

require("./style/index.less");

var _excluded = ["streamId", "title", "streamName", "subTitle", "type", "icon", "showIconFont", "disabled", "curValue", "specialObj", "items", "styleType", "startHandler", "endHandler", "handler"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-pole-slider-out';

var returnText = function returnText(items, curValue) {
  var values = '';
  items.map(function (item) {
    if (item.value === curValue) {
      values = item.text;
    }
  });
  return values;
};

var IOTPoleSlider = function IOTPoleSlider(_ref) {
  var _specialObj$item2, _specialObj$item3;

  var streamId = _ref.streamId,
      title = _ref.title,
      streamName = _ref.streamName,
      subTitle = _ref.subTitle,
      type = _ref.type,
      icon = _ref.icon,
      showIconFont = _ref.showIconFont,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      curValue = _ref.curValue,
      specialObj = _ref.specialObj,
      items = _ref.items,
      styleType = _ref.styleType,
      _ref$startHandler = _ref.startHandler,
      startHandler = _ref$startHandler === void 0 ? function (val) {} : _ref$startHandler,
      _ref$endHandler = _ref.endHandler,
      endHandler = _ref$endHandler === void 0 ? function (val) {} : _ref$endHandler,
      _ref$handler = _ref.handler,
      handler = _ref$handler === void 0 ? function (val) {} : _ref$handler,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(items),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      dataSource = _useState2[0],
      setDataSource = _useState2[1];

  var _useState3 = (0, _react.useState)(curValue),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      currentValue = _useState4[0],
      setcurrentValue = _useState4[1];

  var _useState5 = (0, _react.useState)(curValue ? returnText(items, curValue) : items[0].text),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      currentText = _useState6[0],
      setcurrentText = _useState6[1];

  var defaultDataSource = JSON.parse(JSON.stringify(items));
  (0, _react.useEffect)(function () {
    var dataList = [];

    if (specialObj !== null && specialObj !== void 0 && specialObj.checked && (specialObj === null || specialObj === void 0 ? void 0 : specialObj.item) !== undefined) {
      items.map(function (item) {
        var _specialObj$item;

        if (item.value !== (specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item = specialObj.item) === null || _specialObj$item === void 0 ? void 0 : _specialObj$item.value)) {
          dataList.push(item);
        }
      });
      setDataSource(dataList);
    } else {
      setDataSource(items);
    }
  }, [items, specialObj]);
  (0, _react.useEffect)(function () {
    setcurrentValue(curValue);
    setcurrentText(curValue ? returnText(items, curValue) : items[0].text);
  }, [curValue]);

  var filterHandler = function filterHandler(specialObj) {
    if (!specialObj) return;
    var specialData = JSON.parse(JSON.stringify(specialObj));

    if (!(specialData !== null && specialData !== void 0 && specialData.checked) && (specialData === null || specialData === void 0 ? void 0 : specialData.item) !== undefined) {
      specialData.item = undefined;
      return specialData;
    }

    return specialData;
  };

  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider-top"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider-left"
  }, (icon === null || icon === void 0 ? void 0 : icon.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider-icon"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: ['iot-pole-slider-icon-image', icon !== null && icon !== void 0 && icon.value ? icon.value : 'insideicon-cu-1'].join(' ')
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider-title",
    style: {
      marginLeft: icon !== null && icon !== void 0 && icon.show ? '0' : '.2rem'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider-main"
  }, title)), /*#__PURE__*/_react.default.createElement("div", {
    className: "line"
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "value-unit",
    style: {
      minWidth: '.64rem'
    }
  }, specialObj !== null && specialObj !== void 0 && specialObj.item && specialObj !== null && specialObj !== void 0 && specialObj.checked && curValue === (specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item2 = specialObj.item) === null || _specialObj$item2 === void 0 ? void 0 : _specialObj$item2.value) ? specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item3 = specialObj.item) === null || _specialObj$item3 === void 0 ? void 0 : _specialObj$item3.text : currentText))), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-pole-slider"
  }, /*#__PURE__*/_react.default.createElement(_poleSlider.default, {
    curValue: currentValue + '',
    disabled: false,
    styleType: styleType,
    defaultDataSource: defaultDataSource,
    specialObj: filterHandler(specialObj) // 用户勾选了 并且 设置了item
    ,
    isSpecial: (specialObj === null || specialObj === void 0 ? void 0 : specialObj.checked) && (specialObj === null || specialObj === void 0 ? void 0 : specialObj.item) !== undefined,
    dotsData: dataSource,
    onchange: function onchange(val) {
      var item = {
        streamId: streamId,
        value: val
      };
      handler(item);
    },
    move: function move(val) {
      setcurrentValue(val.currentValue);
      setcurrentText(val.currentText);
    },
    start: function start() {
      startHandler('start');
    }
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "disabled-pangle",
    style: {
      display: "".concat(disabled ? 'block' : 'none')
    }
  })));
};

var _default = IOTPoleSlider;
exports.default = _default;