"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTPoleSlider = _interopRequireDefault(require("./IOTPoleSlider"));

var _utils = require("../../base/utils");

var _grapesjsConfig = require("../IOTCordEntryEnum/grapesjsConfig");

var grapesJSConfig = {
  type: [_type.ComponentsType.EnumType],
  id: 'IOTPoleSlider',
  tag: _type.TagType.IOTPoleSlider,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTPoleSlider.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return; //区分类

    var props = {
      title: property['display-name'],
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      streamId: property.streamName,
      type: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : _property$valuedef.type,
      disabled: false,
      curValue: '',
      //  handler: function (val: any): void {
      //    throw new Error('Function not implemented.');
      //  },
      items: (0, _grapesjsConfig.getEnumItems)(property),
      styleType: '1'
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'select',
      name: 'styleType',
      label: '节点样式',
      options: [{
        value: '1',
        text: '显示节点'
      }, {
        value: '2',
        text: '不显示节点'
      }]
    }, {
      type: 'solt-text',
      name: 'items',
      label: '枚举列表'
    }, {
      type: 'attribute-title',
      name: 'attributeTitle',
      label: '高级属性',
      style: {}
    }, {
      type: 'special-value-setting',
      name: 'specialObj',
      label: '特殊value值设置',
      style: {
        width: 207,
        height: 79
      },
      src: 'https://storage.jd.com/testsmartcloud/special-value.png',
      description: '当控制指令为特殊Value值时，其他值不可使用、点击，特殊Value值一定是通过其他参数触发联动<br />例如：雾量设置-微风/低风/中风/高风/睡眠，睡眠'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;