"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _sliderConfig = require("../../../number/sliderConfig");

var _SliderControl = _interopRequireDefault(require("../../../number/SliderControl"));

require("./style.less");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

//  布局组件
var Slider = function Slider(_ref) {
  var _dotInfoList2, _specialObj$item, _specialObj$item2, _specialObj$item4, _specialObj$item5;

  var _ref$barStyle = _ref.barStyle,
      barStyle = _ref$barStyle === void 0 ? 'line' : _ref$barStyle,
      _ref$isSpecial = _ref.isSpecial,
      isSpecial = _ref$isSpecial === void 0 ? false : _ref$isSpecial,
      specialObj = _ref.specialObj,
      curValue = _ref.curValue,
      styleType = _ref.styleType,
      disabled = _ref.disabled,
      _onchange = _ref.onchange,
      dotsData = _ref.dotsData,
      defaultDataSource = _ref.defaultDataSource,
      _start = _ref.start,
      move = _ref.move;

  var _useState = (0, _react.useState)(''),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      progress = _useState2[0],
      setProgress = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      currentVal = _useState4[0],
      setCurrentVal = _useState4[1];

  var dataSourceList = (0, _sliderConfig.dotInfoList)(dotsData); // const [domParent,setDomParent] = useState();

  var refProgess = (0, _react.useRef)(null);
  var setProcessPercent = (0, _react.useCallback)(function (processPercent) {
    var _dotInfoList;

    var currentValue = 0;
    var currentText = ''; // 步长百分比值(每级所占整个slide长度的百分比值);

    var oneStepPercent = 100 / (dotsData.length - 1); // 1是最小值

    var currentStep = Math.round(processPercent / oneStepPercent) + 1;

    if (currentStep < 1) {
      currentStep = 1;
    }

    if (currentStep > dotsData.length) {
      currentStep = dotsData.length;
    }

    processPercent = (_dotInfoList = (0, _sliderConfig.dotInfoList)(dotsData)[currentStep - 1]) === null || _dotInfoList === void 0 ? void 0 : _dotInfoList.left;
    currentValue = Number.parseFloat(dotsData[currentStep - 1].value);
    currentText = dotsData[currentStep - 1].text;
    move({
      currentValue: currentValue,
      currentText: currentText
    });
    setCurrentVal(currentValue);
    setProgress("".concat(processPercent));
  }, [dotsData, move]);
  (0, _react.useEffect)(function () {
    // value 与 this.currentValue 是否一致;
    var isSame = true; // 通过对比value 与 this.currentValue 是否一致;

    isSame = curValue === currentVal; // 如果不一致 或者dots产生了变化 执行更新方法;

    if (!isSame) {
      var _dotInfoList$currentS;

      var currentStepInd = 0;

      var _iterator = _createForOfIteratorHelper(dotsData.entries()),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var _step$value = (0, _slicedToArray2.default)(_step.value, 2),
              index = _step$value[0],
              elem = _step$value[1];

          if (curValue === elem.value) {
            currentStepInd = index;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      setProgress("".concat((_dotInfoList$currentS = (0, _sliderConfig.dotInfoList)(dotsData)[currentStepInd]) === null || _dotInfoList$currentS === void 0 ? void 0 : _dotInfoList$currentS.left));
    }
  }, [curValue, barStyle, currentVal, dotsData, isSpecial]);
  var SliderChildern = (0, _SliderControl.default)({
    start: function start() {
      _start();
    },
    processHanlder: function processHanlder(processVal) {
      setProcessPercent(processVal);
    },
    onchange: function onchange(changVal) {
      _onchange(changVal);
    },
    currentVal: currentVal,
    refProgess: refProgess
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "Slider"
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      marginLeft: '.225rem'
    }
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "slider-bars"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "slider-bar-inner",
    style: {
      width: "".concat(!isSpecial ? '100%' : ((_dotInfoList2 = (0, _sliderConfig.dotInfoList)(defaultDataSource)[defaultDataSource.length - 2]) === null || _dotInfoList2 === void 0 ? void 0 : _dotInfoList2.left) + '%')
    },
    ref: refProgess
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "progress",
    style: {
      width: "".concat(curValue !== (specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item = specialObj.item) === null || _specialObj$item === void 0 ? void 0 : _specialObj$item.value) ? progress : 0, "%")
    }
  }, curValue !== (specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item2 = specialObj.item) === null || _specialObj$item2 === void 0 ? void 0 : _specialObj$item2.value) && /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: "ball-box"
  }, SliderChildern))), styleType === '1' && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, dataSourceList.map(function (item, index) {
    var _specialObj$item3;

    return /*#__PURE__*/_react.default.createElement("div", {
      key: "".concat(item.text, " ").concat(index),
      className: "point-items ".concat(curValue !== (specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item3 = specialObj.item) === null || _specialObj$item3 === void 0 ? void 0 : _specialObj$item3.value) && Number.parseFloat(progress) > Number.parseFloat(item.left) ? 'point-items-active' : ''),
      style: {
        left: "".concat(item.left, "%")
      }
    });
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "min-max"
  }, dataSourceList.map(function (item, index) {
    return /*#__PURE__*/_react.default.createElement("div", {
      key: "".concat(item.text, " ").concat(index),
      className: "point-text-items",
      style: {
        left: "".concat(item.left, "%")
      }
    }, item.text);
  })))), isSpecial &&
  /*#__PURE__*/
  // curValue === 特殊值时 高亮该点位
  _react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "point-items ".concat(curValue === (specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item4 = specialObj.item) === null || _specialObj$item4 === void 0 ? void 0 : _specialObj$item4.value) ? 'point-items-active' : '', " point-special")
  }), // 是有极时才会出现文字
  styleType === '1' && /*#__PURE__*/_react.default.createElement("div", {
    className: "point-text-special"
  }, specialObj === null || specialObj === void 0 ? void 0 : (_specialObj$item5 = specialObj.item) === null || _specialObj$item5 === void 0 ? void 0 : _specialObj$item5.text))), /*#__PURE__*/_react.default.createElement("div", {
    style: {
      marginRight: '.225rem'
    }
  }), disabled && /*#__PURE__*/_react.default.createElement("div", {
    className: "disabled"
  }));
};

var _default = Slider;
exports.default = _default;