"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _index = _interopRequireDefault(require("../../common/IOTBottomSlide/index"));

var _index2 = _interopRequireDefault(require("./IOTNumberSlider/index"));

var _sliderConfig = require("../sliderConfig");

require("./style/index.less");

var _utils = require("../../base/utils");

var _excluded = ["title", "streamId", "type", "streamName", "curValue", "subTitle", "unit", "icon", "min", "intType", "max", "step", "disabled", "handler", "startHandler", "endHandler", "unitdesc"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-cord-entry-number-out';

var IOTCordEntryNumber = function IOTCordEntryNumber(_ref) {
  var title = _ref.title,
      streamId = _ref.streamId,
      type = _ref.type,
      streamName = _ref.streamName,
      curValue = _ref.curValue,
      subTitle = _ref.subTitle,
      unit = _ref.unit,
      icon = _ref.icon,
      min = _ref.min,
      _ref$intType = _ref.intType,
      intType = _ref$intType === void 0 ? 'float' : _ref$intType,
      max = _ref.max,
      step = _ref.step,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      handler = _ref.handler,
      _ref$startHandler = _ref.startHandler,
      startHandler = _ref$startHandler === void 0 ? function (val) {} : _ref$startHandler,
      _ref$endHandler = _ref.endHandler,
      endHandler = _ref$endHandler === void 0 ? function (val) {} : _ref$endHandler,
      unitdesc = _ref.unitdesc,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      currentValue = _useState2[0],
      setcurrentValue = _useState2[1];

  var _useState3 = (0, _react.useState)(false),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      btmSlider = _useState4[0],
      setBtmSlider = _useState4[1];

  var _useState5 = (0, _react.useState)(Number(curValue)),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      tempValue = _useState6[0],
      setTempValue = _useState6[1];

  var onChange = function onChange(value) {
    setcurrentValue(value); // console.log(value);
  };

  var _useState7 = (0, _react.useState)('com'),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      btmBarType = _useState8[0],
      setBtmBarType = _useState8[1]; // com // show


  (0, _react.useEffect)(function () {
    if (!btmSlider) {
      setcurrentValue(Number.parseFloat((0, _utils.typeConversion)(type, curValue)));
    }
  }, [curValue, btmSlider]);
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-cord-entry-number"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-left"
  }, (icon === null || icon === void 0 ? void 0 : icon.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-icon"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: ['cord-entry-number-icon-image', icon !== null && icon !== void 0 && icon.value ? icon.value : 'insideicon-cu-1'].join(' ')
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-title",
    style: {
      marginLeft: icon !== null && icon !== void 0 && icon.show ? '0' : '.2rem'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-main"
  }, title), (subTitle === null || subTitle === void 0 ? void 0 : subTitle.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-sub"
  }, subTitle['value']))), /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-right",
    onClick: function onClick() {}
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "number-show",
    onClick: function onClick() {
      setBtmSlider(true);
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-text"
  }, curValue, unit), /*#__PURE__*/_react.default.createElement("div", {
    className: "arrow insideicon-entry"
  }))), disabled && /*#__PURE__*/_react.default.createElement("div", {
    className: "cord-entry-number-disable"
  }))), /*#__PURE__*/_react.default.createElement(_index.default, {
    type: btmBarType,
    isShow: btmSlider,
    confirmHandler: function confirmHandler(val) {
      // console.log(val);
      if (val) {
        var item = {
          streamId: streamId,
          value: intType !== 'float' ? tempValue : tempValue.toFixed(1)
        };
        handler && handler(item);
      } else {
        setTempValue(Number(curValue));
      }

      setBtmSlider(false);
    },
    leftText: "\u53D6\u6D88",
    rightText: "\u786E\u5B9A",
    title: title
  }, /*#__PURE__*/_react.default.createElement(_index2.default, {
    min: Number.parseFloat(min),
    max: Number.parseFloat(max),
    step: Number.parseFloat(step),
    unit: unit,
    intType: intType,
    isStep: Number.parseFloat(step) === 1 && Math.round((Number.parseFloat(max) - Number.parseFloat(min)) / Number.parseFloat(step)) > 50,
    showHandleBtn: false,
    curValue: currentValue + '',
    dotsData: (0, _sliderConfig.dataSource)(min, max, step),
    disabled: false,
    onchange: function onchange(val) {
      setTempValue(val); // // console.log(val);
      // const item = {
      //   streamId,
      //   value: intType !== 'float' ? val : val.toFixed(1),
      // };
      // handler && handler(item);
    },
    move: function move(val) {// console.log(val);
      // setcurrentValue(val);
    },
    start: function start() {// startHandler('start');
    }
  })));
};

var _default = IOTCordEntryNumber;
exports.default = _default;