"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTIconSlider = _interopRequireDefault(require("./IOTIconSlider"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.NumberType],
  id: 'IOTIconSlider',
  tag: _type.TagType.IOTIconSlider,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTIconSlider.default, props);
  },
  buildData: function buildData() {
    var _property$valuedef, _property$valuedef$sp, _property$valuedef2, _property$valuedef2$s, _property$valuedef3, _property$valuedef3$s;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return; //区分类

    var props = {
      type: property.valuedef.type,
      streamId: property.streamName,
      title: property['display-name'],
      subTitle: {
        show: true,
        value: '副标题'
      },
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      disabled: false,
      streamName: '',
      curValue: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : (_property$valuedef$sp = _property$valuedef.specs) === null || _property$valuedef$sp === void 0 ? void 0 : _property$valuedef$sp.min,
      unit: property === null || property === void 0 ? void 0 : (_property$valuedef2 = property.valuedef) === null || _property$valuedef2 === void 0 ? void 0 : (_property$valuedef2$s = _property$valuedef2.specs) === null || _property$valuedef2$s === void 0 ? void 0 : _property$valuedef2$s.unit,
      min: property['valuedef']['specs']['min'],
      max: property['valuedef']['specs']['max'],
      unitdesc: property === null || property === void 0 ? void 0 : (_property$valuedef3 = property.valuedef) === null || _property$valuedef3 === void 0 ? void 0 : (_property$valuedef3$s = _property$valuedef3.specs) === null || _property$valuedef3$s === void 0 ? void 0 : _property$valuedef3$s.unitdesc,
      step: property['valuedef']['specs']['step'],
      intType: property['valuedef']['type'],
      leftIcon: '',
      rightIcon: ''
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }];
  }
};
var _default = grapesJSConfig; // import React from 'react';
// import { GrapesjsConfig } from '../../type';
// import { iNumberProps, isIntType } from '../../base/type';
// import IOTIconSlider from './IOTIconSlider';
// import { IOTIconSliderProps } from './interface';
// const defaultTitle = '开关';
// const defaultSubTitle = '副标题';
// const tagName = 'IOTIconSlider';
// const blockName = 'IOTIconSliderBlock';
// const type = 'number';
// export const grapesjsConfig: GrapesjsConfig<IOTIconSliderProps> = {
//   blockConfig: {
//     type: type,
//     blockName: blockName,
//     tagName: tagName,
//     getBlockContent: (ifunction: IOTIconSliderProps) => {
//       return {
//         tagName: ifunction.title ? ifunction.title : '',
//         type: tagName,
//         attributes: {
//           ...ifunction,
//         },
//       };
//     },
//     //组件渲染
//     render: (ifunction: IOTIconSliderProps) => {
// 			var curValue = 0;
//       if (isIntType(ifunction.originType as string)) {
//         curValue = parseInt(ifunction.min ?? 0);
//       } else {
//         curValue = parseFloat(ifunction.min);
//       }
//       const props: IOTIconSliderProps = {
//         ...ifunction,
//         curValue: curValue,
//         startHandler:
//           ifunction.startHandler !== void 0
//             ? ifunction.startHandler
//             : (val: any) => {
//                 // console.log(val, '默认start事件');
//               },
//         endHandler:
//           ifunction.endHandler !== void 0
//             ? ifunction.endHandler
//             : (val: any) => {
//                 // console.log(val, '默认end事件');
//               },
//       };
//       return <IOTIconSlider {...props} />;
//     },
//     buildRender: (ifunction: IOTIconSliderProps) => {
//       return <IOTIconSlider {...ifunction} />;
//     }
//   },
//   typeConfig: {
//     tagName: tagName,
//     traits: (opt: any) => {
//       return [
//         {
//           type: 'option-icon',
//           name: 'icon',
//           label: '显示图标',
//           value: opt.icon,
//         },
//         {
//           type: 'text',
//           name: 'title',
//           value: opt.defaultTitle,
//         },
//       ];
//     },
//     render: (attributes: any) => {
// 				var curValue = 0;
//         if (isIntType(attributes.originType)) {
//           curValue = parseInt(attributes.min ?? 0);
//         } else {
//           curValue = parseFloat(attributes.min);
//         }
//       const props: IOTIconSliderProps = {
//         ...attributes,
//         curValue:
//           attributes.curValue !== void 0 ? Number.parseFloat(attributes.curValue + '') : curValue,
//         startHandler:
//           attributes.startHandler !== void 0
//             ? attributes.startHandler
//             : (val: any) => {
//                 // console.log(val, '默认start事件');
//               },
//         endHandler:
//           attributes.endHandler !== void 0
//             ? attributes.endHandler
//             : (val: any) => {
//                 // console.log(val, '默认end事件');
//               },
//       };
//       return <IOTIconSlider {...props} />;
//     },
//   },
// };

exports.default = _default;