"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _Slider = _interopRequireDefault(require("./Slider/Slider"));

var _sliderConfig = require("../sliderConfig");

require("./style/index.less");

var _excluded = ["streamId", "title", "subTitle", "streamName", "type", "icon", "iconLeft", "iconRight", "min", "max", "intType", "step", "unit", "disabled", "unitdesc", "curValue", "startHandler", "endHandler"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-number-slider-out';

var IOTNumberSlider = function IOTNumberSlider(_ref) {
  var streamId = _ref.streamId,
      title = _ref.title,
      subTitle = _ref.subTitle,
      streamName = _ref.streamName,
      type = _ref.type,
      icon = _ref.icon,
      iconLeft = _ref.iconLeft,
      iconRight = _ref.iconRight,
      min = _ref.min,
      max = _ref.max,
      _ref$intType = _ref.intType,
      intType = _ref$intType === void 0 ? 'float' : _ref$intType,
      step = _ref.step,
      unit = _ref.unit,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      unitdesc = _ref.unitdesc,
      curValue = _ref.curValue,
      _ref$startHandler = _ref.startHandler,
      startHandler = _ref$startHandler === void 0 ? function (val) {} : _ref$startHandler,
      _ref$endHandler = _ref.endHandler,
      endHandler = _ref$endHandler === void 0 ? function (val) {} : _ref$endHandler,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(curValue),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      currentValue = _useState2[0],
      setcurrentValue = _useState2[1];

  (0, _react.useEffect)(function () {
    setcurrentValue(curValue);
  }, [curValue]);
  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "volume-icon-box"
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "volume-icon volume-icon-left ".concat(iconLeft ? iconLeft : 'insideicon-zuixiao', " ")
  })), /*#__PURE__*/_react.default.createElement(_Slider.default, {
    min: Number.parseFloat(min),
    max: Number.parseFloat(max),
    step: Number.parseFloat(step),
    showHandleBtn: false,
    curValue: currentValue + '',
    isStep: Number.parseFloat(step) === 1 && Math.round((Number.parseFloat(max) - Number.parseFloat(min)) / Number.parseFloat(step)) > 50,
    disabled: false,
    dotsData: (0, _sliderConfig.dataSource)(min, max, step),
    onchange: function onchange(val) {
      var item = {
        streamId: streamId,
        value: intType !== 'float' ? val : val.toFixed(1)
      };
      endHandler(item);
    },
    move: function move(val) {
      setcurrentValue(val);
    },
    start: function start() {}
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "volume-icon-box"
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "volume-icon volume-icon-right ".concat(iconRight ? iconRight : 'insideicon-zuida')
  })));
};

var _default = IOTNumberSlider;
exports.default = _default;