"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTNumberSlider = _interopRequireDefault(require("./IOTNumberSlider"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.NumberType],
  id: 'IOTNumberSlider',
  tag: _type.TagType.IOTNumberSlider,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTNumberSlider.default, jsonData);
  },
  buildData: function buildData() {
    var _property$valuedef, _property$valuedef$sp, _property$valuedef2, _property$valuedef2$s, _property$valuedef3, _property$valuedef3$s;

    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    if (property === undefined) return;

    var getConver = function getConver(unit) {
      var timeConver = {
        hoursFlag: false,
        minutesFlag: false,
        secondsFlag: false,
        descText: ''
      };

      if (unit === 'h') {
        timeConver.hoursFlag = true;
      } else if (unit === 'min') {
        timeConver.minutesFlag = true;
      } else if (unit === 's') {
        timeConver.secondsFlag = true;
      }

      return timeConver;
    }; //区分类


    var props = {
      type: property.valuedef.type,
      streamId: property.streamName,
      title: property['display-name'],
      subTitle: {
        show: true,
        value: '副标题'
      },
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      disabled: false,
      streamName: '',
      unit: property === null || property === void 0 ? void 0 : (_property$valuedef = property.valuedef) === null || _property$valuedef === void 0 ? void 0 : (_property$valuedef$sp = _property$valuedef.specs) === null || _property$valuedef$sp === void 0 ? void 0 : _property$valuedef$sp.unit,
      iconLeft: '',
      iconRight: '',
      curValue: property === null || property === void 0 ? void 0 : (_property$valuedef2 = property.valuedef) === null || _property$valuedef2 === void 0 ? void 0 : (_property$valuedef2$s = _property$valuedef2.specs) === null || _property$valuedef2$s === void 0 ? void 0 : _property$valuedef2$s.min,
      intType: property['valuedef']['type'],
      min: property['valuedef']['specs']['min'],
      max: property['valuedef']['specs']['max'],
      unitdesc: property === null || property === void 0 ? void 0 : (_property$valuedef3 = property.valuedef) === null || _property$valuedef3 === void 0 ? void 0 : (_property$valuedef3$s = _property$valuedef3.specs) === null || _property$valuedef3$s === void 0 ? void 0 : _property$valuedef3$s.unitdesc,
      step: property['valuedef']['specs']['step']
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;