"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _react = _interopRequireWildcard(require("react"));

var _sliderConfig = require("../../sliderConfig");

var _SliderControl = _interopRequireDefault(require("../../SliderControl"));

require("./Slider.less");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

//  布局组件
var Slider = function Slider(_ref) {
  var _ref$leftIcon = _ref.leftIcon,
      leftIcon = _ref$leftIcon === void 0 ? "insideicon-reduce" : _ref$leftIcon,
      _ref$rightIcon = _ref.rightIcon,
      rightIcon = _ref$rightIcon === void 0 ? "insideicon-plus" : _ref$rightIcon,
      _ref$barStyle = _ref.barStyle,
      barStyle = _ref$barStyle === void 0 ? 'line' : _ref$barStyle,
      curValue = _ref.curValue,
      min = _ref.min,
      max = _ref.max,
      defaultMin = _ref.defaultMin,
      defaultMax = _ref.defaultMax,
      disabled = _ref.disabled,
      _onchange = _ref.onchange,
      dotsData = _ref.dotsData,
      step = _ref.step,
      _start = _ref.start,
      move = _ref.move,
      _ref$isStep = _ref.isStep,
      isStep = _ref$isStep === void 0 ? true : _ref$isStep,
      _ref$showHandleBtn = _ref.showHandleBtn,
      showHandleBtn = _ref$showHandleBtn === void 0 ? true : _ref$showHandleBtn;

  var _useState = (0, _react.useState)(''),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      progress = _useState2[0],
      setProgress = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      currentVal = _useState4[0],
      setCurrentVal = _useState4[1]; // const [domParent,setDomParent] = useState();


  var refProgess = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    // console.log('Slider, useEffect, curValue', curValue);
    if (curValue !== void 0) {
      if (typeof curValue === 'string') {
        if (Number.parseFloat(curValue) < min) {
          setCurrentVal(min);
          setProgress("".concat(0, "%"));
          return;
        }

        if (Number.parseFloat(curValue) > max) {
          setCurrentVal(max);
          setProgress("".concat(100, "%"));
          return;
        }

        var processPercent = (Number.parseFloat(curValue) - min) * (100 / (max - min));
        setProgress("".concat(processPercent, "%"));
      }
    }
  }, [curValue, min, max, barStyle]);
  var setProcessPercent = (0, _react.useCallback)(function (processPercent) {
    var currentValue = 0; // 无极

    if (isStep) {
      var valueDiff = max - min;

      if (processPercent <= 0) {
        processPercent = 0;
        currentValue = min;
      } else if (processPercent >= 100) {
        processPercent = 100;
        currentValue = max;
      } else {
        var s = valueDiff * processPercent / 100 + min;
        currentValue = Number.parseInt(s.toString());
      }
    } // 有极
    else {
      var _dotInfoList;

      // 步长百分比值(每级所占整个slide长度的百分比值);
      var oneStepPercent = 100 / (dotsData.length - 1); // 1是最小值

      var currentStep = Math.round(processPercent / oneStepPercent) + 1;

      if (currentStep < 1) {
        currentStep = 1;
      }

      if (currentStep > dotsData.length) {
        currentStep = dotsData.length;
      }

      processPercent = (_dotInfoList = (0, _sliderConfig.dotInfoList)(dotsData)[currentStep - 1]) === null || _dotInfoList === void 0 ? void 0 : _dotInfoList.left;
      currentValue = dotsData[currentStep - 1].text;
    }

    move(currentValue); // // console.log(currentValue);

    setCurrentVal(currentValue);
    setProgress("".concat(processPercent, "%"));
  }, [dotsData, isStep, max, min, move]);
  (0, _react.useEffect)(function () {
    if (isStep) return; // value 与 this.currentValue 是否一致;

    var isSame = true; // 通过对比value 与 this.currentValue 是否一致;

    isSame = curValue === currentVal; // 如果不一致 或者dots产生了变化 执行更新方法;

    if (!isSame) {
      // 无级
      if (isStep) {
        if (curValue < min) {
          setCurrentVal(min);
          return;
        }

        if (curValue > max) {
          setCurrentVal(max);
          return;
        }

        setProgress(JSON.stringify((curValue - min) * (100 / (max - min))));
      } else {
        var _dotInfoList$currentS;

        var currentStepInd = 0;

        var _iterator = _createForOfIteratorHelper(dotsData.entries()),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var _step$value = (0, _slicedToArray2.default)(_step.value, 2),
                index = _step$value[0],
                elem = _step$value[1];

            if (curValue === JSON.stringify(elem.text)) {
              currentStepInd = index;
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        setProgress("".concat((_dotInfoList$currentS = (0, _sliderConfig.dotInfoList)(dotsData)[currentStepInd]) === null || _dotInfoList$currentS === void 0 ? void 0 : _dotInfoList$currentS.left, "%"));
      }
    }
  }, [curValue, min, max, barStyle, isStep, currentVal, dotsData]);
  var SliderChildern = (0, _SliderControl.default)({
    start: function start() {
      _start();
    },
    processHanlder: function processHanlder(processVal) {
      setProcessPercent(processVal);
    },
    onchange: function onchange(changVal) {
      _onchange(changVal);
    },
    currentVal: currentVal,
    refProgess: refProgess
  });
  return /*#__PURE__*/_react.default.createElement("div", {
    className: "Slider"
  }, showHandleBtn ? /*#__PURE__*/_react.default.createElement("div", {
    className: "icon icon-left ".concat(leftIcon, " ").concat(Number.parseFloat(min + '') === Number.parseFloat(curValue + '') ? 'icon-disabled' : ''),
    onClick: function onClick() {
      if (disabled) return;
      var addValue = 0; // 无极

      if (isStep) {
        addValue = Number(curValue) * 10 - step * 10;
      } else {
        // 有极 最后一项和倒数第二项差
        var stepTemp = dotsData[dotsData.length - 1].text - dotsData[dotsData.length - 2].text; // ===0 说明整个数组等分取step

        var stepTemp1 = stepTemp !== 0 ? stepTemp : step; // Number(curValue) === dotsData[dotsData.length - 1].text 是最后一个，取差值，不是取step

        addValue = Number(curValue) * 10 - (Number(curValue) === dotsData[dotsData.length - 1].text ? stepTemp1 : step) * 10;
      }

      var value = addValue / 10 < min ? min : addValue / 10;

      _onchange(value);
    }
  }) : /*#__PURE__*/_react.default.createElement("div", {
    className: "icon icon-number-left "
  }, defaultMin), /*#__PURE__*/_react.default.createElement("div", {
    className: "slider-bar"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "slider-bar-inner",
    ref: refProgess
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "progress",
    style: {
      width: progress
    }
  }, /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: "ball"
  }, SliderChildern))), showHandleBtn && /*#__PURE__*/_react.default.createElement("div", {
    className: "min-max"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "min"
  }, defaultMin), /*#__PURE__*/_react.default.createElement("div", {
    className: "max"
  }, defaultMax)))), showHandleBtn ? /*#__PURE__*/_react.default.createElement("div", {
    className: "icon icon-right ".concat(rightIcon, "  ").concat(Number.parseFloat(max + '') === Number.parseFloat(curValue + '') ? 'icon-disabled' : ''),
    onClick: function onClick() {
      if (disabled) return;
      var addValue = Number(curValue) * 10 + step * 10;
      var value = addValue / 10 > max ? max : addValue / 10;

      _onchange(value);
    }
  }) : /*#__PURE__*/_react.default.createElement("div", {
    className: "icon icon-number-right"
  }, defaultMax), disabled && /*#__PURE__*/_react.default.createElement("div", {
    className: "disabled"
  }));
};

var _default = Slider;
exports.default = _default;