"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _utils = require("./utils");

var _fatSlider = _interopRequireDefault(require("./fatSlider/fatSlider"));

var _sliderConfig = require("../sliderConfig");

require("./style/index.less");

var _excluded = ["streamId", "streamName", "title", "subTitle", "icon", "min", "max", "step", "timeConver", "disabled", "unit", "unitdesc", "curValue", "leftIcon", "rightIcon", "startHandler", "endHandler"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-time-slider-out';

var IOTTimeSlider = function IOTTimeSlider(_ref) {
  var streamId = _ref.streamId,
      streamName = _ref.streamName,
      title = _ref.title,
      subTitle = _ref.subTitle,
      icon = _ref.icon,
      min = _ref.min,
      max = _ref.max,
      step = _ref.step,
      timeConver = _ref.timeConver,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$unit = _ref.unit,
      unit = _ref$unit === void 0 ? 'min' : _ref$unit,
      unitdesc = _ref.unitdesc,
      curValue = _ref.curValue,
      leftIcon = _ref.leftIcon,
      rightIcon = _ref.rightIcon,
      _ref$startHandler = _ref.startHandler,
      startHandler = _ref$startHandler === void 0 ? function (val) {} : _ref$startHandler,
      _ref$endHandler = _ref.endHandler,
      endHandler = _ref$endHandler === void 0 ? function (val) {} : _ref$endHandler,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(''),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      displayValue = _useState2[0],
      setDisplayValue = _useState2[1]; // const [displayHelpInfos, setDisplayHelpInfos] = useState<DisplayHelpInfos>({ minVal: Number(min), maxVal: Number(max), stepVal: Number(step), initValue: curValue, displayTimeType: 'mm:ss' });
  // useEffect(() => {
  //   const { hoursFlag, minutesFlag, secondsFlag } = timeConver;
  //   const _max = Number.parseInt(max);
  //   const _min = Number.parseInt(min);
  //   const _step = Number.parseInt(step);
  //   const _curValue = curValue;
  //   const _displayHelpInfos: DisplayHelpInfos = { minVal: _min, maxVal: _max, stepVal: _step, initValue: _curValue, displayTimeType: 'mm:ss' };
  //   // 展示精确到秒
  //   if (secondsFlag) {
  //     // 默认单位是分钟
  //     if (unit === 'min') {
  //       _displayHelpInfos.maxVal = _displayHelpInfos.maxVal * 60;
  //       _displayHelpInfos.minVal = _displayHelpInfos.minVal * 60;
  //       _displayHelpInfos.stepVal = _displayHelpInfos.stepVal * 60;
  //       _displayHelpInfos.initValue = _displayHelpInfos.initValue * 60;
  //     }
  //     // 默认单位是小时
  //     if (unit === 'h') {
  //       _displayHelpInfos.maxVal = _displayHelpInfos.maxVal * 60 * 60;
  //       _displayHelpInfos.minVal = _displayHelpInfos.minVal * 60 * 60;
  //       _displayHelpInfos.stepVal = _displayHelpInfos.stepVal * 60 * 60;
  //       _displayHelpInfos.initValue = _displayHelpInfos.initValue * 60 * 60;
  //     }
  //     // 展示格式设置
  //     if (minutesFlag) {
  //       // 展示为 时：分：秒格式
  //       if (hoursFlag) {
  //         _displayHelpInfos.displayTimeType = 'hh:mm:ss';
  //         // 展示为 分：秒格式
  //       } else {
  //         _displayHelpInfos.displayTimeType = 'mm:ss';
  //       }
  //     } else {
  //       _displayHelpInfos.displayTimeType = 'ss';
  //     }
  //     // 展示精确到分钟
  //   } else if (minutesFlag) {
  //     // 默认单位是小时
  //     if (unit === 'h') {
  //       _displayHelpInfos.maxVal = _displayHelpInfos.maxVal * 60;
  //       _displayHelpInfos.minVal = _displayHelpInfos.minVal * 60;
  //       _displayHelpInfos.stepVal = _displayHelpInfos.stepVal * 60;
  //       _displayHelpInfos.initValue = _displayHelpInfos.initValue * 60;
  //     }
  //     // 默认单位是秒
  //     if (unit === 's') {
  //       _displayHelpInfos.maxVal = _displayHelpInfos.maxVal / 60;
  //       _displayHelpInfos.minVal = _displayHelpInfos.minVal / 60;
  //       _displayHelpInfos.stepVal = _displayHelpInfos.stepVal / 60;
  //       _displayHelpInfos.initValue = _displayHelpInfos.initValue / 60;
  //     }
  //     // 展示格式设置
  //     // 展示为 时：分格式
  //     if (hoursFlag) {
  //       _displayHelpInfos.displayTimeType = 'hh:mm';
  //     } else {
  //       _displayHelpInfos.displayTimeType = 'mm';
  //     }
  //     // 展示精确到小时
  //   } else if (hoursFlag) {
  //     // 默认单位是分钟
  //     if (unit === 'min') {
  //       _displayHelpInfos.maxVal = _displayHelpInfos.maxVal / 60;
  //       _displayHelpInfos.minVal = _displayHelpInfos.minVal / 60;
  //       _displayHelpInfos.stepVal = _displayHelpInfos.stepVal / 60;
  //       _displayHelpInfos.initValue = _displayHelpInfos.initValue / 60;
  //     }
  //     // 默认单位是秒
  //     if (unit === 's') {
  //       _displayHelpInfos.maxVal = _displayHelpInfos.maxVal / (60 * 60);
  //       _displayHelpInfos.minVal = _displayHelpInfos.minVal / (60 * 60);
  //       _displayHelpInfos.stepVal = _displayHelpInfos.stepVal / (60 * 60);
  //       _displayHelpInfos.initValue = _displayHelpInfos.initValue / (60 * 60);
  //     }
  //     _displayHelpInfos.displayTimeType = 'hh';
  //   }
  //   setDisplayHelpInfos({ ..._displayHelpInfos });
  // }, [timeConver, step, max, min, curValue, unit]);


  var onChange = function onChange(val) {
    var value = (0, _utils.formatTime)(val, unit, timeConver);
    setDisplayValue(value);
  };

  (0, _react.useEffect)(function () {
    var value = (0, _utils.formatTime)(Number.parseInt(curValue), unit, timeConver);
    setDisplayValue(value);
  }, [curValue, timeConver]);
  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider-top"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider-left"
  }, (icon === null || icon === void 0 ? void 0 : icon.show) && /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider-icon"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: ['iot-time-slider-icon-image', icon !== null && icon !== void 0 && icon.value ? icon.value : 'insideicon-cu-1'].join(' ')
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider-title",
    style: {
      marginLeft: icon !== null && icon !== void 0 && icon.show ? '0' : '.2rem'
    }
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider-main"
  }, title)), /*#__PURE__*/_react.default.createElement("div", {
    className: "line"
  }), /*#__PURE__*/_react.default.createElement("div", {
    className: "value-unit",
    style: {
      minWidth: '.64rem'
    }
  }, " ", displayValue, timeConver.descText))), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-time-slider-number"
  }, /*#__PURE__*/_react.default.createElement(_fatSlider.default, {
    min: Number.parseInt(min),
    max: Number.parseInt(max),
    step: 1,
    showHandleBtn: false // isStep={Number.parseFloat(step) === 1 &&(Math.round((Number.parseFloat(max) - Number.parseFloat(min)) / Number.parseFloat(step)) >50) }
    ,
    curValue: Number.parseInt("".concat(curValue)),
    dotsData: (0, _sliderConfig.dataSource)(min, max, step),
    disabled: false,
    onchange: function onchange(val) {
      var item = {
        streamId: streamId,
        value: val
      };
      endHandler(item);
    },
    move: function move(val) {
      onChange(val);
    },
    start: function start() {
      startHandler('start');
    }
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "disabled-pangle",
    style: {
      display: "".concat(disabled ? 'block' : 'none')
    }
  })));
};

var _default = IOTTimeSlider;
exports.default = _default;