"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var sliderWidth;
var sliderOffsetLeft; // let touchs: any;

var startX;
var startY;
var isTouched;
var isHorizontalMoved;

/**
 * 
 * @param start 开始触摸事件
 * @param processHanlder move事件
 * @param onchange 触摸结束后事件
 * @param currentVal 参数值
 * @param refProgess ref实例 
 * @returns 
 */
var SliderControl = function SliderControl(_ref) {
  var start = _ref.start,
      processHanlder = _ref.processHanlder,
      onchange = _ref.onchange,
      currentVal = _ref.currentVal,
      refProgess = _ref.refProgess;

  var _onTouchStart = (0, _react.useCallback)(function (e) {
    var doms = refProgess.current;
    sliderWidth = parseFloat(doms.getBoundingClientRect().width);
    sliderOffsetLeft = parseFloat(doms.getBoundingClientRect().left);
    var touchs = e.changedTouches[0];
    startX = touchs.pageX;
    startY = touchs.pageY;
    isTouched = true;
    isHorizontalMoved = false;
    start();
  }, [start]);

  var _onTouchMove = (0, _react.useCallback)(function (e) {
    var touchs = e.changedTouches[0];
    var currentX = touchs.pageX;
    var currentY = touchs.pageY;
    var diffX = Math.abs(currentX - startX);
    var diffY = Math.abs(currentY - startY); // 在第一次触发touchmove时 判断是左右滑还是上下滑
    // 左右滑动时才是触动了滑杆的滑动 isHorizontalMoved = true;

    if (isTouched) {
      if (diffX * 0.8 > diffY) {
        isHorizontalMoved = true;
      }

      isTouched = false;
    }

    var processPercent = (currentX - sliderOffsetLeft) / sliderWidth * 100; // 只有在左右滑动时 滑杆才产生变化;

    if (isHorizontalMoved) {
      processHanlder(processPercent);
    }
  }, [processHanlder]);

  var _onTouchEnd = (0, _react.useCallback)(function () {
    if (isHorizontalMoved) {
      onchange(currentVal);
    } else {// console.log('没有拖动不触发下发');
    }
  }, [currentVal, onchange]);

  return {
    onTouchStart: function onTouchStart(e) {
      return _onTouchStart(e);
    },
    onTouchMove: function onTouchMove(e) {
      return _onTouchMove(e);
    },
    onTouchEnd: function onTouchEnd() {
      return _onTouchEnd();
    },
    onTouchCancel: function onTouchCancel() {
      return _onTouchEnd();
    }
  };
};

var _default = SliderControl;
exports.default = _default;