"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.dotInfoList = exports.dataSource = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

var dataSource = function dataSource(min, max, step) {
  var minTemp = Number.parseFloat(min);
  var maxTemp = Number.parseFloat(max);
  var stepTemp = Number.parseFloat(step); // 切割后的循环数

  var num = 0; // 数组 [{value: 10, text: '低档'}]

  var dataList = [];
  num = Math.round((maxTemp - minTemp) / stepTemp); // 最大值距离循环后的最大值的差
  // 5 % 2
  //   // console.log(100 % 0.2) === 0.19999999999999446

  var lastStep = maxTemp - (num * stepTemp + minTemp); // 生成数组 [{value: 10, text: '低档'}]

  for (var i = 0; i < (lastStep < 0 ? num : num + 1); i++) {
    dataList.push({
      value: i + 1,
      // lastStep === 0说明和step值一样
      text: (stepTemp * 10 * i + minTemp * 10) / 10
    });
  } // lastStep !== 0 说明有余数，不取余数，操作小数不是很精确，新添加最大值到数组的最后一个


  if (lastStep !== 0) {
    dataList.push({
      value: dataList.length + 1,
      text: maxTemp
    });
  } // console.log(dataList)


  return dataList;
};

exports.dataSource = dataSource;

var dotInfoList = function dotInfoList(dotsData) {
  var aInfoList = [];
  var dotsLength = dotsData.length;

  if (dotsLength > 0) {
    var oneStepPercent = 100 / (dotsLength - 1);

    for (var i = 0; i < dotsLength; i += 1) {
      var aInfo = {
        icon: ''
      };
      var hasIcon = !!dotsData[i].icon;

      if (hasIcon) {
        aInfo = _objectSpread(_objectSpread({}, aInfo), {}, {
          icon: dotsData[i].icon
        });
      }

      if (i === dotsLength - 1) {
        aInfo = _objectSpread(_objectSpread({}, aInfo), {}, {
          left: 100
        });
      } else {
        var pos = oneStepPercent * i;
        aInfo = _objectSpread(_objectSpread({}, aInfo), {}, {
          left: pos
        });
      }

      aInfo = _objectSpread(_objectSpread({}, aInfo), {}, {
        text: dotsData[i].text,
        value: dotsData[i].value
      });
      aInfoList.push(aInfo);
    }
  }

  return aInfoList;
};

exports.dotInfoList = dotInfoList;