"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

require("./style/index.less");

var _utils = require("../../base/utils");

var _alert_icon = _interopRequireDefault(require("./static/alert_icon.png"));

var _excluded = ["message", "jugements", "isBuild", "streams"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var prefixCls = 'iot-alert-out';

var IOTAlert = function IOTAlert(_ref) {
  var message = _ref.message,
      jugements = _ref.jugements,
      _ref$isBuild = _ref.isBuild,
      isBuild = _ref$isBuild === void 0 ? false : _ref$isBuild,
      streams = _ref.streams,
      rest = (0, _objectWithoutProperties2.default)(_ref, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      show = _useState2[0],
      setShow = _useState2[1];

  var _useState3 = (0, _react.useState)(''),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      text = _useState4[0],
      setText = _useState4[1];

  (0, _react.useEffect)(function () {
    condJudgment(jugements, streams);
  }, [streams]);

  var condJudgment = function condJudgment(jugements, streams) {
    if (!isBuild || jugements.length === 0) {
      setText(message);
      setShow(true);
      return;
    }

    if (!jugements || !Array.isArray(jugements)) {
      setText(message);
      setShow(true);
      return;
    } // const jugement = jugements[0];
    // const ifCondition = jugement['ifCondition'];
    // const thenCondition = jugement['thenCondition'];
    // const flag = judgmentCondition(ifCondition,streams);


    var trueJugements = [];
    jugements.map(function (item) {
      var ifCondition = item['ifCondition'];
      var flag = judgmentCondition(ifCondition, streams);
      item.flag = flag;

      if (flag) {
        trueJugements.push(item);
      }
    });

    if (trueJugements.length > 0) {
      setText(trueJugements[0].thenCondition[0]['value']);
      setShow(true);
    } else {
      setShow(false);
    }
  };

  var judgmentCondition = function judgmentCondition(ifCondition, streams) {
    var flag = false;
    var lastJudgement;

    for (var j = 0; j < ifCondition.length; j++) {
      var condition = ifCondition[j];
      var ifs = condition['if'];
      var currentFlag = judgmentBracketCondition(ifs, streams);

      if (lastJudgement === '||') {
        flag = flag || currentFlag;
      } else if (lastJudgement === '&&') {
        flag = flag && currentFlag;
      } else {
        flag = currentFlag;
      }

      lastJudgement = condition['judgement'];
    }

    return flag;
  };

  var judgmentBracketCondition = function judgmentBracketCondition(ifs, streams) {
    var flag = false;
    var lastJudgement = '';

    for (var k = 0; k < ifs.length; k++) {
      var ifCond = ifs[k];
      var currentFlag = (0, _utils.condJudgmentForOne)(ifCond, streams);

      if (lastJudgement === '||') {
        flag = flag || currentFlag;
      } else if (lastJudgement === '&&') {
        flag = flag && currentFlag;
      } else {
        flag = currentFlag;
      }

      lastJudgement = ifCond['judgement'];
    }

    return flag;
  };

  return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
    className: prefixCls,
    style: {
      display: "".concat(show ? 'block' : 'none')
    }
  }, rest), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-alert"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-alert-icon"
  }, /*#__PURE__*/_react.default.createElement("img", {
    src: _alert_icon.default,
    alt: ""
  })), /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-alert-content"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "iot-alert-message"
  }, text))));
};

var _default = IOTAlert;
exports.default = _default;