"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getEnumItems = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTConsumables = _interopRequireDefault(require("./IOTConsumables"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.Consumables],
  id: 'IOTConsumables',
  tag: _type.TagType.IOTConsumables,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTConsumables.default, jsonData);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    // 区分类
    var props = {
      title: '耗材剩余情况',
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      subTitle: {
        show: true,
        value: '耗材状态：'
      },
      type: '',
      streamId: 'consumables',
      thumbnailTheme1: 'https://iotfestatic.s3.cn-north-1.jdcloud-oss.com/%E5%B0%8F%E4%BA%AC%E9%B1%BC%E5%B9%B3%E5%8F%B0/%E6%8B%96%E6%8B%BD%E5%B9%B3%E5%8F%B0%E9%9D%99%E6%80%81%E8%B5%84%E6%BA%90/thumbnailTheme1.png',
      thumbnailTheme12: 'https://storage.jd.com/testsmartcloud/dcp_consumable.png',
      disabled: false,
      streamValue: 100,
      handler: function handler() {// throw new Error('Function not implemented.');
      }
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'setConsumables',
      name: 'consumablesList',
      label: '耗材配置'
    }];
  }
};

var getEnumItems = function getEnumItems(propery) {
  var _propery$valuedef, _propery$valuedef$spe;

  var items = Array();
  var values = propery === null || propery === void 0 ? void 0 : (_propery$valuedef = propery.valuedef) === null || _propery$valuedef === void 0 ? void 0 : (_propery$valuedef$spe = _propery$valuedef.specs) === null || _propery$valuedef$spe === void 0 ? void 0 : _propery$valuedef$spe.values;

  for (var key in values) {
    // 对此对象属性中的每个键执行的代码
    items.push({
      text: values["".concat(key)],
      value: key,
      icon: 'insideicon-cu-1'
    });
  }

  return items;
};

exports.getEnumItems = getEnumItems;
var _default = grapesJSConfig;
exports.default = _default;