"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTDataLog = _interopRequireDefault(require("./IOTDataLog"));

var _utils = require("../../base/utils");

var grapesJSConfig = {
  type: [_type.ComponentsType.IOTDataLog],
  id: 'IOTDataLog',
  tag: _type.TagType.IOTDataLog,
  access: 'r',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTDataLog.default, props);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    var props = {
      title: '数据记录',
      dataSource: [{
        time: "19:30:23",
        content: '数据记录信息'
      }, {
        time: "19:30:21",
        content: '数据记录信息'
      }, {
        time: "19:30:19",
        content: '数据记录信息'
      }, {
        time: "19:30:17",
        content: '数据记录信息'
      }],
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      type: 'dataLog',
      streamId: 'dataLog'
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'data-log-bind-stream',
      name: 'datalog',
      label: '关联功能'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;