declare type IconInfo = {
    show: boolean;
    value: string;
};
export declare type IOTDataLogInfo = {
    dataSource: any[];
    confirmChange: (val: string) => void;
    activeDate: string;
    icon: IconInfo;
    title: string;
    more: boolean;
    loadMore: () => Promise<void>;
};
declare type valueDef = {
    specs: any;
    type: string;
};
declare type NavigationCommonType = {
    bindType?: string;
    functionName?: string;
    handler: (item?: any) => void;
    icon?: string;
    streamName?: string;
    id?: string;
    label?: string;
    streamId?: string;
    title?: string;
    type?: string;
    curValue?: any;
    disabled?: boolean;
    unitConvertFlag?: any;
    valueDef?: valueDef;
};
export declare type EnumItems = {
    text: string;
    value: string;
    checked: boolean;
};
export declare type NavigationEnumProps = {
    items: EnumItems[];
} & NavigationCommonType;
export declare type NavigationLinkProps = {
    linkType: string;
    url: string;
} & NavigationCommonType;
export declare type NavigationNumberProps = NumberSlideType & NavigationCommonType;
export declare type NumberSlideType = {
    streamId: string;
    min: string;
    max: string;
    step: string;
    unit: string;
    unitdesc: string;
    curValue: string;
    handler?: any;
    intType?: string;
};
export interface IOTBottomSlideProps {
    leftText: string;
    rightText: string;
    title?: string;
    isShow: boolean;
    type: string;
    confirmHandler: (val: any) => void;
}
export declare type IOTBottomSlideJson = IOTBottomSlideProps;
export {};
