"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../../base/utils");

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTTimeTask = _interopRequireDefault(require("./IOTTimeTask"));

var grapesJSConfig = {
  type: [_type.ComponentsType.cloudTimer],
  id: _type.TagType.IOTTimeTask,
  tag: _type.TagType.IOTTimeTask,
  access: 'rw',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    return /*#__PURE__*/_react.default.createElement(_IOTTimeTask.default, props);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    var props = {
      list: [],
      type: '',
      streamId: 'timeTask',
      title: '定时设置',
      subTitle: {
        value: '今日暂无定时',
        show: true
      },
      icon: {
        value: 'insideicon-cu-1',
        show: true
      },
      disabled: false
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'option-icon',
      name: 'icon',
      label: '显示图标'
    }, {
      type: 'text',
      name: 'title',
      label: ''
    }, {
      type: 'image-card',
      name: 'clockTask',
      label: '定时任务',
      theme1Src: 'https://iotfestatic.s3.cn-north-1.jdcloud-oss.com/%E5%B0%8F%E4%BA%AC%E9%B1%BC%E5%B9%B3%E5%8F%B0/%E6%8B%96%E6%8B%BD%E5%B9%B3%E5%8F%B0%E9%9D%99%E6%80%81%E8%B5%84%E6%BA%90/timetaskTheme1.png',
      theme12Src: 'https://iotfestatic.s3.cn-north-1.jdcloud-oss.com/%E5%B0%8F%E4%BA%AC%E9%B1%BC%E5%B9%B3%E5%8F%B0/%E6%8B%96%E6%8B%BD%E5%B9%B3%E5%8F%B0%E9%9D%99%E6%80%81%E8%B5%84%E6%BA%90/timetaskTheme12.png',
      style: {
        width: 200,
        height: 400
      }
    }, {
      type: 'bind-multiple-stream',
      name: 'list',
      label: '绑定功能',
      tips: '定时任务页面将按照您在此处勾选参数的顺序展示',
      description: '点击下面的参数名称，选择当前产品可以设置的定时任务'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;