"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _utils = require("../../base/utils");

var _react = _interopRequireDefault(require("react"));

var _type = require("../../base/type");

var _IOTWeather = _interopRequireDefault(require("./IOTWeather"));

var grapesJSConfig = {
  type: [_type.ComponentsType.WeatherType],
  id: _type.TagType.IOTWeather,
  tag: _type.TagType.IOTWeather,
  access: 'r',
  render: function render(jsonData) {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    var props = _utils.mergeParameters.apply(void 0, [jsonData].concat(args));

    var weather = props.weather;
    var location = weather.location,
        temperature = weather.temperature,
        humidity = weather.humidity,
        pm25 = weather.pm25;
    props.weather = {
      location: {
        flag: location,
        text: '定位失败'
      },
      pm25: {
        flag: pm25,
        text: '500'
      },
      temperature: {
        flag: temperature,
        text: '-25℃'
      },
      humidity: {
        flag: humidity,
        text: '100%'
      }
    };
    return /*#__PURE__*/_react.default.createElement(_IOTWeather.default, props);
  },
  buildData: function buildData() {
    var mock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
    var property = arguments.length > 1 ? arguments[1] : undefined;
    var props = {
      weather: {
        location: true,
        temperature: true,
        humidity: true,
        pm25: true
      }
    };
    return props;
  },
  traits: function traits() {
    return [{
      type: 'weather',
      name: 'weather',
      label: '添加配置'
    }];
  }
};
var _default = grapesJSConfig;
exports.default = _default;